C........................................................Sep 2023
C Interpolate 2d maps for missed intermediate map
C........................................................Nov 2019
C
C T.L.Gulyaeva...........................................Oct. 2012
C Interpolate 2h UT file of IONEX format to missed dayly data file
C
C outfile: IONEX 'uhsg' file
C
C Include input of IONEX_1h file <uhrgXXX0.12i>+anygXXX0.12i file
C                                              +anygYYY0.12i file  
C 
C
C +++++++++++++++++++++++++++++++++++
C
C
C T.L.Gulyaeva...........................................Jan 2010
C 
      PROGRAM MAPINTER2x2
C----------------------------------------------------------------
C Extract TEC at given glat x glon table <statusf.txt>
C
C glat= 87.5, 85,...,-85, -87,5 = 71 lines => 71 sets of 12 files for 2h UT bins
C glon= -180,-175,..., +175, 180  = 0,...,72 columns
C
C-------------------------------------------------------------------
C program for EXTRACTING FROM "JPLGdoy0.iYR" ionex_TEC data 
C
C*********TEST
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
      CHARACTER*3 XXX,YYY,ZZZ
	CHARACTER*80 INFILE1,INFILE2,OUTFILE,TLATLON
	CHARACTER*71 txt72
C_	+,indate
	CHARACTER*4 AYEAR,BYEAR,CYEAR,CTIME,NAME,AYEAR_pre
	CHARACTER*60 txt
	CHARACTER*16 txt1,start
	character*2 ayr,amn,dy1,dy2,aut,CMN,CDY,DD2,AMN_pre,ADY_pre
	+,ADY_nex,ADY
	+,BMN,BDY
		integer*2 iyr,imn,idy1,idy2,iut,jut,nfile
	dimension im(12),x1(16),x2(16),xx(16),y1(4),y2(4),yy(4)
c//     +,tecp1(71,0:72),tecp2(71,0:72),tecp3(71,0:72)  ! 
	dimension ires1(16),ires2(4) 
C?	     COMMON  /CONST/UMR
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	IRUN=0
		start='START OF TEC MAP'
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
	cyear=DD(1:4)
  	 cmn=DD(5:6)
	cdy=DD(7:8)			 
	ctime=TT
  799	format(A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,I3))				 !FEB2015 NEW COMMAND NUMBER = 799
  798	format(' YEAR, AMN, DD2 = ',A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,I3))
C   	indate='d:/web/graf/date'    !!! Tamara !!!!!!!	 !FEB2015
C	open(10,file=indate)							   !FEB2015			
C	read(10,799) AYEAR,AMN,DD2,AYEAR_pre,AMN_pre,ADY_pre,lda,lda_pre  !FEB2015 NEW FORMAT NUMBER = 799
C	WRITE(*,798) AYEAR, AMN, DD2,AYEAR_pre,AMN_pre,ADY_pre,lda,lda_pre !FEB2015 NEW FORMAT NUMBER = 798
C	close(unit=10)

      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C

C	WRITE(*,*) 'Enter <uhrg> or <ehrg> for scaling input: '
C	read(*,118) namesc
C
      name='jplr'						! unknowqn JPLR file
	WRITE(*,*) 'Enter input YEAR : '
C	read(*,118) AYEAR
	ayr=AYEAR(3:4)
	read(ayr,*) ryr
	iyr=int(ryr)
C
	WRITE(*,*) 'Enter input MN : '
	read(*,116) AMN
	read(amn,*) rmn
	imn=int(rmn)
C
      WRITE(*,'(\A\)') ' ENTER <iDY1>,<iDY2> OF INPUT FILES='
      READ(*,'(A)') iDY1,iDY2
	call blet2(idy1,DY1)
	call blet2(idy2,DY2)
C      DY1=ADY_pre
C	ADY=DD2
C	DY2=DD2
CC CALCULATION OF DAY OF YEAR	(LDA)
	if(int(ryr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
C
	lda1=ndoy(iyr,imn,idy1)
	lda2=ndoy(iyr,imn,idy2)
		lda3=lda1+1  !intermediate day
	call blet3(lda1,XXX)
	call blet3(lda2,YYY)
 	call blet3(lda3,ZZZ)  !intermediate day
	 idy2=idy1+1
C	call blet2(idy3,ADY_nex)

C
	infile1='d:\web\graf\teci\jplrXXX0.23i'
	infile1(27:28)=ayr
	infile1(22:24)=XXX
C    infile1 & infile2 for day XXX & ZZZ
	infile2=infile1
	infile2(22:24)=YYY
C infile 3 and outfile for day YYY
C ADD
c outfile =================================
C
crem	outfile='d:\web\graf\teci\upcgYYY0.12i'
	outfile=infile2
C	outfile(19:20)='pc'
	outfile(22:24)=ZZZ
		OPEN(11,FILE=INFILE1)
		OPEN(12,FILE=INFILE2)
		OPEN(14,FILE=OUTFILE)

C fix hour step:
c	if (name(2:2).eq.'h') then
	idelh=1
	iruns=24
C	       else
C	idelh=2
C	iruns=13
C	endif
C end fix

  116	format(A2)
  118	format(A4)
c	pause  ' '
C?   80	do i=1,2000					             !!
C?	READ (11,187,END=88,ERR=2) txt,txt1
C?	if (txt1.eq.start) then 
C?	write(*,187) txt,txt1
C?	goto 88
C?	endif
C?	enddo									 !!
  88	continue
  280	do i=1,2000					             !!
	READ (12,187,END=288,ERR=2) txt,txt1
	if (i.le.26) then
	write(*,187) txt,txt1
	write(14,187) txt,txt1
	endif
	if (txt1.eq.start) then 
	write(*,187) txt,txt1
	write(14,187) txt,txt1
	goto 288
	endif
	enddo									 !!
  288	continue

C =========================================
C Cycle on UT;;;;;;;;;;;;;;;;;;;;;;;;;;;;
C	do 488 iut=0,24,idelh
C
	do 488 iut=0,24
	call blet2(iut,AUT)
c
C
C Start input for given UT:++++++++++++++++++++
C
175	CONTINUE
C
  176 format(A128)
  107	FORMAT(1X,A13,A2,3X,2(F5.1,1X),27X,I1,34X,2(F6.1))		   
C =========================================
C  
  700	 continue
C?		iflag=0
C
c//	ih0=-1
C  Start of UT selection for given day:
C
  187	format(A60,A16)
c ***************************************************************
C start cycle on hr-to-hr input:
C	if (iut.lt.24) then
	iutc=iut
C	else
C	iutc=0
C	endif
  150    read (11,89,end=85,err=85) byear,bmn,bdy,jut
	if (bdy(1:1).eq.' ') bdy(1:1)='0'
	if (bmn(1:1).eq.' ') bmn(1:1)='0'
      if ((byear.eq.ayear).and.(bmn.eq.amn).and.(bdy.eq.dy1)
	+.and.(jut.eq.iutc)) then
	backspace(11)
      READ (11,187,END=288,ERR=2) txt,txt1
	write(*,1187) ayear,amn,ady,jut,txt1
	write(14,1187) ayear,amn,ady,jut,txt1
	goto 85
1187	FORMAT(2X,A4,4X,A2,4X,A2,4X,I2,36X,A16)
	            else
	goto 150
	endif
   85	continue
c      write(*,*) txt1
c	pause ' '

   89 format(2X,A4,4X,A2,4X,A2,4X,I2)
C Start of reading VTEC ========================

  250	read (12,89,end=285,err=285) byear,bmn,bdy,jut
      if (bdy(1:1).eq.' ') bdy(1:1)='0'
	if (bmn(1:1).eq.' ') bmn(1:1)='0'

	if ((byear.eq.ayear).and.(bmn.eq.amn).and.(bdy.eq.ady2)
	+.and.(jut.eq.iutc)) then
C	write(*,89) byear,bmn,bdy,jut
C 	write(14,89) byear,bmn,bdy,jut
	goto 285
	            else
	goto 250
	endif
  285	continue
      write(*,89) ayear,amn,ady,jut
 	write(14,89) ayear,amn,ady,jut
C
  90	format(3X,F5.1,A72)
C------------------------------------------------------------
C Cycle on lats 90:2:-90
        DO 487 ilat=90,-90,-2
C
   10	read(11,90,err=2,end=9) glat,txt72
      read(12,90,err=2,end=9) glat,txt72
      write(*,90) glat,txt72
	write(14,90) glat,txt72
C
180	format(16(1X,F4.0))
179	format(4(1X,F4.0))
C
	trem=20.
C
	do j=1,11
	j1=(j-1)*16
     	READ (11,180,END=9,ERR=2) (x1(i),i=1,16)
	READ (12,180,END=9,ERR=2) (x2(i),i=1,16)
	do k=1,16
	if ((x1(k).le.0.).or.(x1(k).gt.9990.)) then
	x1(k)=trem ! replace wrong TEC
	endif
	if ((x2(k).le.0.).or.(x2(k).gt.9990.)) then
	x2(k)=trem ! replace wrong TEC
	endif
       ave=(x1(k)+x2(k))/2.
	ires1(k)=nint(ave)
	enddo
	write(*,391) (ires1(k),k=1,16)
	write(14,391) (ires1(k),k=1,16)
	enddo
C
     	READ (11,180,END=9,ERR=2) (y1(i),i=1,4)
	READ (12,180,END=9,ERR=2) (y2(i),i=1,4)
	do k=1,4
	if ((y1(k).le.0.).or.(y1(k).gt.9990.)) then
	y1(k)=trem ! replace wrong TEC
	endif
	if ((y2(k).le.0.).or.(y2(k).gt.9990.)) then
	y2(k)=trem ! replace wrong TEC
	endif
       ave=(y1(k)+y2(k))/2.
	ires2(k)=nint(ave)
	enddo
	write(*,392) (ires2(k),k=1,4)
	write(14,392) (ires2(k),k=1,4)
C +++++++++++ 
  390 format(A80)
  391 format(16(1X,I4))
  392 format(4(1X,I4))
C Output of scaled line:
C	write(*,390) TLATLON
C	write(14,390) TLATLON
  487 CONTINUE ! end lat cycle
C++++++++++++++++++++++++++++++++++++++++++++++++++++
C
	READ (11,187,END=88,ERR=2) txt,txt1
		READ (12,187,END=88,ERR=2) txt,txt1
	write(*,187) txt,txt1
	write(14,187) txt,txt1  !END OF TEC MAP
C
C?	READ (11,187,END=88,ERR=2) txt,txt1
C?		if (txt1.eq.start) then
C?          backspace(11)
C?	write(*,187) txt,txt1
C?	write(14,187) txt,txt1
C?	endif
C?	READ (12,187,END=88,ERR=2) txt,txt1
C	write(*,187) txt,txt1
C	write(14,187) txt,txt1
C?	READ (12,187,END=88,ERR=2) txt,txt1
c	write(*,187) txt,txt1
C?	if (txt1.ne.start) then
C?	backspace(13)
C?	endif
c     write(*,187) txt,txt1
c	write(14,187) txt,txt1
C	if (iut.eq.24-idelh) then
C	dy1=dy2
C	endif
C
  488	CONTINUE  ! end UT cycle
C
	close(unit=11)
	close(unit=12)
	close(unit=14)
	goto 35
C 
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	    	pause ' '
 35      write(*,*) infile1,infile2,outfile
      pause ' ' 
      STOP
       END

C 
C==============================================================================
	SUBROUTINE SUBREAD1(nn,title,itxx)
	INTEGER itxx(0:72),ixx(16)
	character*80 title,txt
	integer*2 nn
  190 format(A80)
  191 format(16(1X,I4))
  192 format(9(1X,I4))

	read(nn,190) title
	read(nn,190) txt
	backspace(nn)
crem	DO 777 lat=1,71	   ! Start cycle on glati ++++++++++++++++++++++++++++++++
crem		ilat=ilat+1   ! ilat=1 for 87.5
crem	glati=glati-2.5
c   77	DO kl=1,72                 ! cycle on latitudes
c//   87	read (111,90,end=9,err=2) glat,txt
   90	format(3X,F5.1,A60)
  91   	j1=0
C
C Add check of wrong TEC.le.0<=itec_pre +++++++++++++
C
	itec_pre=20	  ! assumed TEC_pre 
	do j=1,4        
	j1=(j-1)*16
   1	READ (nn,180,END=9,ERR=2) (ixx(i),i=1,16)
  180	format(16(1X,I4))
	do k=1,16
	if (ixx(k).le.9) ixx(k)=itec_pre  ! replace wrong TEC
	itxx(j1+k-1)=ixx(k)
	itec_pre=ixx(k)		! latest TEC_pre
	enddo
	enddo			  ! start selection of 4 longitudes
	READ (nn,179,END=9,ERR=2) (ixx(i),i=1,9)
  179	format(9(1X,I4))
	do k=1,9
	if (ixx(k).le.9) ixx(k)=itec_pre  ! replace wrong TEC
	itxx(64+k-1)=ixx(k)
	itec_pre=ixx(k)		! latest TEC_pre
	enddo
	goto 9
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	    	pause ' '
	goto 9

    9	RETURN
	END
	 
C
C***********************************************************
