CC.......................................................May. 2016
C Produce mean TEC or pTEC-monthly-UT in magnetic coordinates 
C from d:/web/dts/toMNDDUT.jYR or d:/web/dts/poMNDDUT.jYR
C 
C JPL hourly results in magn. coords
C.....................
C
C T.L.Gulyaeva........
C 
      PROGRAM MAPTEC9M
C----------------------------------------------------------------
C Select all latitudes: res1=-87.5N,-85N,,,,,0,...,87.5 
C                        
C each line in input file for TEC at:mlong [0, 5,...360E]
C separate files for UT=0,1,2,3,...23hUT
C output array: res(0:72)
C all results for given year, including YRMNDY
C
C*********TEST
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*80 INFILE,OUTFILE
	+,inglats,inglons
C>	+,OUTFILE1,OUTFILE0,OUTFILE2  ! Sea=>outfile0, land=>outfile1
	CHARACTER*4 AYEAR
	CHARACTER*131 txt
	character*2 ayr,amn,ady,aut
	CHARACTER*1 pt
C>	+,dy1,dy2
C>	logical sout  ! true~sea, false ~ land
c-	character*3 aday
C>	integer*2 iidy,iyr,imn,iut
	dimension itxx(0:72),im(12),itxx0(0:72),rtav(0:72)
C>	+,gecoef(71)
C>     +,iamp(0:7)
	+,glats(71,0:72),glons(71,0:72)
	dimension res(0:72),rgec(0:24),igec(0:24),iroc(0:24)
c     +,pgec(0:24) ! prec.day
	+,res1(0:72),res0(0:72),rgec1(0:24),rgec0(0:24)
     +,igec1(0:24),igec0(0:24)
C??	     COMMON  /CONST/UMR
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C>	       outfile2='atech.mtc' ! Areal ATEC 
C>		OPEN(13,FILE=OUTFILE2,ACCESS='APPEND')
      pt='p'   !pTEC
c
C Read geogr. coords. for magn. grids
	inglats='glatgrid1.txt'
	inglons='glongrid1.txt'
  102	format(73(1X,I4))
  101	format(73(1X,F5.1))
	OPEN(10,file=inglats)
	OPEN(11,file=inglons)
C

	do i=1,71
	read(10,101) (glats(i,k),k=0,72)
	do k=0,72
	if (glats(i,k).gt.87.5) glats(i,k)=87.5
	if (glats(i,k).lt.-87.5) glats(i,k)=-87.5
	enddo
      read(11,101) (glons(i,k),k=0,72)
	enddo
	close(unit=10)
	close(unit=11)
C++

118	format(A4)
c	pause  ' '
333	WRITE(*,*) ' ENTER YEAR OF INPUT FILE='	 !1998.09 ... 2015.12
      READ(*,*) AYEAR
	ayr=ayear(3:4)
	read(ayr,*) ryr 
      iyr=int(ryr)
	WRITE(*,*) ' ENTER MN OF INPUT FILE='	 !1998.09 ... 2015.12
      READ(*,*) AMN
 	read(amn,*) rmn
	imn=int(rmn) 
 
C??	if (iyr.eq.16) GOTO	135
	read(ayear,*) year
c	if (year.eq.1998) then
c	imn=9
c	amn='09'
c	endif
  1	IRUN=0

CC CALCULATION OF DAY OF YEAR	(LDA)
	iiyr=int(year)
	if(int(year/4.)*4.eq.iiyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	idy1=1
	idy2=im(imn)

	xdy=1.      ! start day-of-month
C
C Start input for given UT:++++++++++++++++++++
C
  273 FORMAT(1X,I2)
	cntmn=0.
	resmn=0.
	cntmn0=0.
	resmn0=0.
	cntmn1=0.
	resmn1=0.
C Cycle day-to-day +++++++++++++++++++++++++++++
  700	iidy=int(xdy)
C-	write(*,273) iidy
	do n=0,24
	rgec(n)=0.
	enddo
	call blet2(iidy,ADY)
C
C
	lda=ndoy(iyr,imn,iidy)
	daynr=float(lda)
c-  178	call blet3(lda,ADAY)
C
	infile='d:\web\dts\YR\MN\toMNDDUT.jYR'		 ! TEC or pTEC in magn.coord.
	infile(18:18)=pt
C
 
      infile(12:13)=ayr
	infile(15:16)=amn
	infile(20:21)=amn
	infile(22:23)=ady
	infile(28:29)=ayr
C
c   11	continue     ! 
c   27 format(6X,F3.1)

c ***************************************************************
C start cycle on hr-to-hr input:
	DO 775 iut=0,23
 	rut=float(iut)	
	call blet2(iut,AUT)
	infile(24:25)=AUT
		      OPEN(111,FILE=INFILE)
   80	AEC=0.
	AEC1=0. !land
	AEC0=0.	!sea
	cntav1=0.
	cntav0=0.
	cntav=0.
	do k=0,72
 	itxx0(k)=0.		! prec. lati TECeff
	enddo
C
C start cycle on mlatitudes:
	gmlati=-90.0
	cntlats=0.
	DO 777 lat=1,71	   ! Start cycle on mlati 
	gmlati=gmlati+2.5

	cntlats=cntlats+1.
C+
	res(lat)=0.			! total tec
	res1(lat)=0.        ! TEC1 for each glat land
	res0(lat)=0.        ! TEC0 for each glat sea
	do k=0,72
 	itxx(k)=0.		! curr. lati TEC
	enddo
C++++++++++++++++++
C read  TEC for current lati
	READ (111,187,END=33,ERR=2) (itxx(k),k=0,72) 
  187	format(73(1X,I4))
c  88	continue
c   85	continue

C++++++++++++++++++
C
C Select values for MLong=0,5,...,355...!!!!!!!!!!!!:
C
171	nlon=-1
C
 	sum=0. 		 ! total TEC
	cnt=0.
	
C prepare calculation of TEC1 (Land) & TEC0 (Sea):
C 1-Land, 0- Sea
      sum1=0.		 ! TEC1
	cnt1=0.
	sum0=0.		 ! TEC0
	cnt0=0.
	do 776 il=0,360,5     ! for long-cycle
	nlon=nlon+1
	gmlong=float(il) 
	glati=glats(lat,nlon)
	glong=glons(lat,nlon)
cc=	if (glong.lt.0.) glong=glong+360.        
C++++++++

C
	rtav(nlon)=float(itxx(nlon))
  172    sum=sum+rtav(nlon)
	cnt=cnt+1.
C++			 
C Check position Sea/Land 
C	call sealand(glati,glong,sout)
C
	if (sout) then		 !true ~ sea
	cnt0=cnt0+1			  ! Sea
	sum0=sum0+rtav(nlon)
	else
	cnt1=cnt1+1			 !false ~ land
		sum1=sum1+rtav(nlon)
	endif

C
 776	continue ! long cycle
	res(lat)=sum
	res1(lat)=sum1
	res0(lat)=sum0
 182	format(3A2,24(1X,I4))							
 121 	AEC=AEC+res(lat)
	AEC1=AEC1+res1(lat)
	AEC0=AEC0+res0(lat)
	do i=0,72
	itxx0(i)=itxx(i)  ! prec. lati TEC
	itxx(i)=0.
	enddo
	cntav1=cntav1+cnt1
	cntav0=cntav0+cnt0
	cntav=cntav+cnt
C
 777  continue  ! lati cycle

C --------------- 
C OUTPUT OF RESULTS
  9	continue
CC
 176  FORMAT(1X,I2,2X,E12.6)
c	do kk=1,72
c1	write(*,176) iut,GEC
c1	write(12,176) iut,GEC
c	enddo
	rgec(iut)=AEC/(cntav)  !
 	rgec1(iut)=AEC1/(cntav1)  !
      rgec0(iut)=AEC0/(cntav0)  !
  775 continue   ! End calculation for given UT
C Continue to the next UT hr :
  32		irun=irun+1 
C	iutend=iruns
	iutend=24
C>	      if (irun.lt.iutend) goto 80 ! continue to the next UT hr =>>>>
C
CC
C-	GOTO 1277
C Output of daily results
C
C
	sum=0.
	sum1=0.
	sum0=0.
	do i=0,23           
	sum=sum+rgec(i) ! aver using UT=0,...,23 h
	sum1=sum1+rgec1(i) ! aver using UT=0,...,23 h
	sum0=sum0+rgec0(i) ! aver using UT=0,...,23 h
	igec(i)=nint(rgec(i))
	igec1(i)=nint(rgec1(i))
	igec0(i)=nint(rgec0(i))
c//	pgec(i)=rgec(i)    ! keep results for prec.day+++++++++++++++++++++
c//	pgec1(i)=rgec1(i)    ! keep results for prec.day+++++++++++++++++++++
c//	pgec0(i)=rgec0(i)    ! keep results for prec.day+++++++++++++++++++++
c-	if (i.lt.24) iroc(i)=nint((rgec(i+1)-rgec(i))*100.) ! rate-of-change
	enddo
	sum=sum/240. ! aver using UT=0,...,23 h
	sum1=sum1/240. ! aver using UT=0,...,23 h
	sum0=sum0/240. ! aver using UT=0,...,23 h TECU
c-	iroc(24)=nint(sum*100)
	iaver=nint(sum) 
	iaver1=nint(sum1) 
	iaver0=nint(sum0) 
C
C      Add output of 4 title lines
	IF ((iidy.eq.0).and.(imn.eq.1)) THEN
	txt(1:3)='AEC'
C>	write(12,275) txt
	txt(5:9)='Sea'
C>	write(10,275) txt
	txt(5:9)='Land'
C>	write(11,275) txt 
C>	write(*,275) txt
  275 format(A10)
C>	WRITE(12,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C>	WRITE(11,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C>	WRITE(10,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
	txt(1:9)='YYMMDD|UT'
	do k=0,24
	iroc(k)=k
	enddo
  276 format(A9,24(I2,3X))	
C>      write(*,276) txt,(iroc(k),k=0,23)
C>	write(12,276) txt,(iroc(k),k=0,23)
C>	write(11,276) txt,(iroc(k),k=0,23)
C>	write(10,276) txt,(iroc(k),k=0,23)
	txt(1:50)='--------------------------------------------------'
	txt(51:100)='--------------------------------------------------'
	txt(101:131)='--------------------------     '
  274 format(A131)
C>	write(12,274) txt
C>	write(11,274) txt
C>	write(10,274) txt
C>	write(*,274) txt
	ENDIF
C
C>	write(*,177) ayr,amn,ady,(igec(i),i=0,23)  ! GEC
C>	write(12,177) ayr,amn,ady,(igec(i),i=0,23)
C>	write(11,177) ayr,amn,ady,(igec1(i),i=0,23)
C>	write(10,177) ayr,amn,ady,(igec0(i),i=0,23)
 177  format(3A2,24(1X,I4))

C+++++++++++++++++++++++++++++++++++++++++++++++
C>	write(*,277) ayr,amn,ady,sum,sum1,sum0	 ! total, land, sea
C>	write(13,277) ayr,amn,ady,sum,sum1,sum0	 ! 
C> 277  format(3A2,8(1X,I4),3(2X,I4))
C> 277  format(3A2,3(2X,F8.2))
C	pause ' '
C 
 1277     xdy=xdy+1.
C> 1277	continue
		irun=0
cc=	irun=irun+1
c	pause ' '
	close(unit=111)
	iidy=int(xdy)
	if ((iidy.le.idy2).and.(idy1.lt.idy2)) then
      resmn=resmn+sum
	resmn0=resmn0+sum0
	resmn1=resmn1+sum1
	goto 700                ! continue for the next day of month
	else
		goto 33	   ! end of calculations
	endif
C
c	write (*,888) alat,alon,aday
c  888	format(1X,' alat=',A3,' alon=',A3,' day=',A3)

    2 CONTINUE
      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
 	pause ' '
	goto 35
      endif
  277  format(1X,2A2,3(2X,F8.2))
 33	      resmn=resmn/idy2
 	resmn0=resmn0/idy2
	resmn1=resmn1/idy2
	write(*,277) ayr,amn,resmn,resmn1,resmn0	 ! total, land, sea
	write(13,277) ayr,amn,resmn,resmn1,resmn0 ! 
 
C>      if ((iidy.le.idy2).and.(idy1.lt.idy2)) goto 32
	xdy=1.
	imn=imn+1
      call blet2(imn,amn)
	if ((iyr.eq.15).and.(imn.lt.11)) then !TEMP
	GOTO 1
	else
      if (imn.lt.13) GOTO 1
	endif
   35      write(*,*) infile,outfile2
	write(*,*) irun
C>	close (unit=10)
C>	close (unit=11)
C> 	close (unit=12)
C>	close (unit=13)
C>	if ((imn.lt.12).and.(iyr.ne.15)) GOTO 1
C>>	if (iyr.ne.16) GOTO 1
	if (iyr.ne.16) goto 333
135   		close (unit=13)
      pause ' ' 
      STOP
       END

C***********************************************************
