      program cntpeut
C.........................................................Sep 2021
C Prediction efficiency: GTEC ~ UPC, GTEC ~ JPL 
C                      IRI-PLasTEC ~ UPC, IRI-plas ~ JPL
C                      IRI-2016TEC ~ UPC, IRI-2016 ~ JPL
C TECave(UT) => PE(UT) UT=0,1,...,23 h
C ......................................................July 2021
C Cycle on grid maps to 
C produce rms between two maps-data
C Grids = 71 lats 0:72 long
C
C ======= data of TEC maps =======================
C
      DIMENSION DA1(71,0:72),da2(71,0:72)
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*48 INFILE1,INFILE2,OUTFILE
C
c
C ===============================
C
     	outfile='cntpeut.txt'
   1	      OPEN(13,FILE=OUTFILE,access='APPEND')
C
       WRITE(*,*)' ENTER YR <-1> STOP'
	read(*,*) AYR
	if (AYR.eq.'-1') goto 133

C+	infile1='d:\web\gtc\YR\MN\gtMN15UT.sYR'		!GTEC median
Temp	infile2='fc0MNmap.asc'
C+	infile2='d:\web\graf\dtu\YR\MN\tmMN15UT.uYR'   ! UPC obs median
      infile2='d:\web\dts\YR\MN\tcMN00UT.mYR'   ! JPL obs median
C+	infile1='d:\web\dts\YR\MN\tnMN15UT.mYR'   ! IRI-Plas TEC median	CCIR
	infile1='d:\web\dtc\YR\MN\tcMN15UT.iYR'   ! IRI-2016 TEC median	CCIR

		infile1(12:13)=ayr
		infile1(28:29)=ayr
C+		infile2(17:18)=ayr   !UPC
C+		infile2(33:34)=ayr	 !UPC
		infile2(12:13)=ayr  !JPL
		infile2(28:29)=ayr	!JPL
      WRITE(*,*)' ENTER MN'
	read(*,*) AMN
		infile1(15:16)=amn
		infile1(20:21)=amn
C+		infile2(20:21)=amn	  !UPC
C+		infile2(25:26)=amn	  !UPC
		infile2(15:16)=amn	  !JPL
		infile2(20:21)=amn	  !JPL
  30	format(2(1X,A2))
C-      WRITE(*,*)' ENTER idy1,idy2'
C-	read(*,*) idy1,idy2
C
         write(*,30) AYR,AMN
	write(13,30) AYR,AMN
C-      DO 101 idy=idy1,idy2
        idy=15   ! median
	call blet2(idy,ADY)

c-		infile1(30:31)=ady
c-		infile2(30:31)=ady
C
         ntot=0
	totrms=0.
	totav1=0.
	totav2=0.
	DO 770 iut=0,23
	call blet2(iut,AUT)
C
	infile1(24:25)=aut
	infile2(24:25)=aut	 !JPL
C+	infile2(29:30)=aut	  !UPC
 
C
		 open(11,file=infile1,action='READ')
	open(12,file=infile2,action='READ')
  21	continue		
C      write(*,*) infile1,infile2
      if (iut.eq.0) then
	write(13,*) infile1,infile2
      endif
C
C Start input of 1st file: -----------------------
C
       obsave=0.
        DO lat=1,71
CC
        do kk=0,72
	DA1(lat,kk)=0.
	DA2(lat,kk)=0.
	  enddo
  703	read(11,704,end=705) (DA1(lat,k),k=0,72)
  704	format(73(1X,F4.1))
C
C =======================================================
C Start input of 2nd file: Obs
 1703	read(12,704,end=199) (DA2(lat,k),k=0,72)
       do k=0,72
	obsave=obsave+da2(lat,k)
	 enddo
C
        enddo      ! end reading lat, long
	 tecave=obsave/5173.
C-  705 close(unit=11)
c-  199 close(unit=12)
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Output of results RMS after calculation:
  	rms=0.
	dev=0.
	nn=0
	av1=0.
	av2=0.
	dtop=0.
	dbot=0.
C
	do mm=1,71
      do 198 ii=0,72
	if (da1(mm,ii).eq.0.) goto 198
	av1=av1+da1(mm,ii)
	av2=av2+da2(mm,ii)
	del=da1(mm,ii)-da2(mm,ii)  !
	dtop=dtop+del**2
	dbot=dbot+(da2(mm,ii)-tecave)**2
	dev=dev+del
	rms=rms+del**2.
	nn=nn+1
  198	continue	  ! lon cycle
	enddo       ! lats cycle
	pe=1.0-sqrt(dtop/dbot)
	if (nn.gt.0) then
	rmsq=sqrt(rms/nn)
	dev=dev/nn
	endif
	totrms=totrms+rms
	totav1=totav1+av1
	totav2=totav2+av2
C
Temp	WRITE(113,158) iut,rms,rmsq,dev,nn
	WRITE(*,158) AYR,AMN,ADY,AUT,pe
	WRITE(13,158) AYR,AMN,ADY,AUT,pe
 158  FORMAT(1X,4(A2),1X,F8.3)
c
	ntot=ntot+1
  705 close(unit=11)
  199 close(unit=12)
  770 CONTINUE      ! end cycle on UT
	stot=sqrt(totrms/(nn*ntot))
	sav1=totav1/(nn*ntot)
	sav2=totav2/(nn*ntot)
c-	WRITE(*,159) AYR,AMN,ADY,stot,sav1,sav2
c-	WRITE(13,159) AYR,AMN,ADY,stot,sav1,sav2

C  159	format(1X,'RMSmaps=',F10.3,' av1=',F10.3,' av2=',F10.3)
  159	format(1X,3A2,3(1X,F10.3))


  699 continue	  ! 
	goto 101
C
  101	continue   ! dayly cycle
  132	close(unit=13)
	write(*,*) infile1,infile2
	goto 1
 133	pause '  '
      STOP
	END
c--------------------------------------------------------------------

C Corr-coef calculation:
	subroutine corcoef(nn,res1,res2,corf,sf12)
C	nn - number of pair X,Y
	dimension res1(999),res2(999)
	cnt=float(nn)
	af1f2=0.
	af1=0.
	af2=0.
	aff1=0.
	aff2=0.

C
	do i=1,nn
	af1f2=af1f2+res1(i)*res2(i)
	af1=af1+res1(i)
	af2=af2+res2(i)
	aff1=aff1+res1(i)*res1(i)
	aff2=aff2+res2(i)*res2(i)
	enddo
	af1f2=af1f2/cnt
	af1=af1/cnt
	af2=af2/cnt
	aff1=aff1/cnt
	aff2=aff2/cnt

	corf=(af1f2-af1*af2)/(sqrt(aff1-af1*af1)*sqrt(aff2-af2*af2))

C  Dispersion:
	sf1=sqrt(aff1-af1*af1)
	sf2=sqrt(aff2-af2*af2)
	sf12=sf2*sqrt(1.-corf)
	bf21=corf*sf2/sf1
	avf1=af1
	avf2=af2

C Output of results
c	WRITE(*,150) corf,sf12,corx,sx12,avf1,sf1,avf2,sf2,bf21
c	+,avx1,sx1,avx2,sx2,bx21,ii
	RETURN
	end