      program cntrmsmap3
C rmse between median maps: JPLmed ~ UPCmed
C ......................................................July 2021
C Cycle on grid maps to 
C produce rms between two maps-data
C Grids = 71 lats 0:72 long
C
C ======= data of TEC maps =======================
C
      DIMENSION DA1(71,0:72),da2(71,0:72),intc(0:71)
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*48 INFILE1,INFILE2,OUTFILE
C
c
C ===============================
C
     	outfile='mapxrms3.txt'
   1	      OPEN(13,FILE=OUTFILE,access='APPEND')
C
       WRITE(*,*)' ENTER YR'
	read(*,*) AYR

C	infile1='d:\web\gtc\YR\MN\gtMN15UT00.sYR'		!GTEC median
	infile1='d:\web\graf\dtu\YR\MN\tmMN15UT.uYR'   ! UPC obs median
	infile2='d:\web\dts\YR\MN\tcMN00UT.mYR'   ! JPL obs median
C-		infile1(12:13)=ayr
C-		infile1(30:31)=ayr
		infile1(17:18)=ayr  !UPC
		infile1(33:34)=ayr	!UPC
		infile2(12:13)=ayr  !JPL
		infile2(28:29)=ayr	!JPL
      WRITE(*,*)' ENTER MN'
	read(*,*) AMN
C-		infile1(15:16)=amn
C-		infile1(20:21)=amn
		infile1(20:21)=amn	  !UPC
		infile1(25:26)=amn	  !UPC
		infile2(15:16)=amn	  !JPL
		infile2(20:21)=amn	  !JPL
  30	format(2(1X,A2))
C-      WRITE(*,*)' ENTER idy1,idy2'
C-	read(*,*) idy1,idy2
C
         write(*,30) AYR,AMN
	write(13,30) AYR,AMN
C-      DO 101 idy=idy1,idy2
        idy=15   ! median
	call blet2(idy,ADY)

c-		infile1(30:31)=ady
c-		infile2(30:31)=ady
C
         ntot=0
	totrms=0.
	totav1=0.
	totav2=0.
	DO 770 iut=0,23
	call blet2(iut,AUT)
C
C-	infile1(24:25)=aut
	infile1(29:30)=aut	 !UPC
	infile2(24:25)=aut	 !JPL
 
C
		 open(11,file=infile1,action='READ')
	open(12,file=infile2,action='READ')
  21			write(*,*) infile1,infile2
      if (iut.eq.0) then
	write(13,*) infile1,infile2
      endif
C
C Start input of 1st file: -----------------------
C
        DO lat=1,71
CC
        do kk=0,72
	DA1(lat,kk)=0.
	DA2(lat,kk)=0.
	  enddo
  703	read(11,704,end=705) (DA1(lat,k),k=0,72)
  704	format(73(1X,F4.1))
C
C =======================================================
C Start input of 2nd file:
 1703	read(12,701,end=199) (intc(k),k=0,72)
 701	format(73(1X,I4))
       do k=0,72
	da2(lat,k)=intc(k)/10.
	 enddo
C
        enddo      ! end reading lat, long
C  705 close(unit=11)
C  199 close(unit=12)
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Output of results RMS after calculation:
  	rms=0.
	dev=0.
	nn=0
	av1=0.
	av2=0.
C
	do mm=1,71
      do 198 ii=0,72
	av1=av1+da1(mm,ii)
	av2=av2+da2(mm,ii)
	del=da1(mm,ii)-da2(mm,ii)
	dev=dev+del
	rms=rms+del**2.
	nn=nn+1
  198	continue	  ! lon cycle
	enddo       ! lats cycle
	if (nn.gt.0) then
	rmsq=sqrt(rms/nn)
	dev=dev/nn
	endif
	totrms=totrms+rms
	totav1=totav1+av1
	totav2=totav2+av2
C
Temp	WRITE(113,158) iut,rms,rmsq,dev,nn
	WRITE(*,158) AYR,AMN,ADY,AUT,rms,rmsq,dev,nn
C?	WRITE(13,158) AYR,AMN,ADY,AUT,rms,rmsq,dev,nn
 158  FORMAT(1X,3(A2),1X,A2,1X,F10.3,2(2X,F8.3),2X,I4)
c
  705 close(unit=11)
  199 close(unit=12)
	ntot=ntot+1
c
  770 CONTINUE      ! end cycle on UT
	stot=sqrt(totrms/(nn*ntot))
	sav1=totav1/(nn*ntot)
	sav2=totav2/(nn*ntot)
	WRITE(*,159) AYR,AMN,ADY,stot,sav1,sav2
	WRITE(13,159) AYR,AMN,ADY,stot,sav1,sav2

C  159	format(1X,'RMSmaps=',F10.3,' av1=',F10.3,' av2=',F10.3)
  159	format(1X,3A2,3(1X,F10.3))


  699 continue	  ! 
	goto 101
C
  101	continue   ! dayly cycle
  132	close(unit=13)
	write(*,*) infile1,infile2
	goto 1
	pause '  '
      STOP
	END
c--------------------------------------------------------------------

C Corr-coef calculation:
	subroutine corcoef(nn,res1,res2,corf,sf12)
C	nn - number of pair X,Y
	dimension res1(999),res2(999)
	cnt=float(nn)
	af1f2=0.
	af1=0.
	af2=0.
	aff1=0.
	aff2=0.

C
	do i=1,nn
	af1f2=af1f2+res1(i)*res2(i)
	af1=af1+res1(i)
	af2=af2+res2(i)
	aff1=aff1+res1(i)*res1(i)
	aff2=aff2+res2(i)*res2(i)
	enddo
	af1f2=af1f2/cnt
	af1=af1/cnt
	af2=af2/cnt
	aff1=aff1/cnt
	aff2=aff2/cnt

	corf=(af1f2-af1*af2)/(sqrt(aff1-af1*af1)*sqrt(aff2-af2*af2))

C  Dispersion:
	sf1=sqrt(aff1-af1*af1)
	sf2=sqrt(aff2-af2*af2)
	sf12=sf2*sqrt(1.-corf)
	bf21=corf*sf2/sf1
	avf1=af1
	avf2=af2

C Output of results
c	WRITE(*,150) corf,sf12,corx,sx12,avf1,sf1,avf2,sf2,bf21
c	+,avx1,sx1,avx2,sx2,bx21,ii
	RETURN
	end