      program extmap24cc
C..................................................................Feb.2023
C Source 1x1 JPLI maps
C Output: 2.5 x 5 JPL IONEX maps 00, 01,..., 23 UT
C
C
C
	dimension XX(360),IXX_pre(360),IXX_cur(360),YY(0:72),ires(0:72)
	CHARACTER*48 INFILE,outfile
	character*2 ayr,amn,ady,aut
	CHARACTER*4 AYEAR
C
	infile='d:\web\dtt\YR\MN\tiMNDDUT00.jYR'	  ! 1x1 grid
	outfile='d:\web\graf\dtc\YR\MN\ut\tiMNDDUT.jYR' ! 2.5 x 5 grid
C
  20	      WRITE(*,'(\A\)') ' ENTER YEAR ='
      READ(*,'(A)') AYEAR
ctemp	AYEAR='2012'  !ctemp
		ayr=ayear(3:4)

      WRITE(*,'(\A\)') ' ENTER MN ='
      READ(*,'(A)') AMN
ctemp	amn='01'
		WRITE(*,*) 'Enter ndy1, ndy2 : '
 	read(*,987) nndy,ndyend
  987	format(I2)
C?	call blet2(nndy,DY1)
C?	call blet2(ndyend,DY2)
C
	if (amn.eq.'00') goto 33
C
C Start ----------------------------
       infile(12:13)=AYR
	infile(15:16)=AMN
	infile(20:21)=AMN
	infile(30:31)=AYR
         outfile(17:18)=AYR
	outfile(20:21)=AMN
	outfile(28:29)=AMN
	outfile(36:37)=AYR
C
         DO 101 idy=nndy,ndyend
	call blet2(idy,ADY)
	infile(22:23)=ADY
	outfile(30:31)=ADY
C
        DO 66 iut=0,23
	call blet2(iut,AUT)
	infile(24:25)=AUT
	outfile(32:33)=AUT
	OPEN(11,file=infile,action='READ')
C
	OPEN(12,file=outfile)
C   21   irun=irun+1
C
C
	xav=0.
	glat=-90.5	 ! infile
	xlat=-87.5   ! outfile
C Lati cycle
	do lat=1,180
	glat=glat+1.0
	glat1=glat+1.0
	read(11,24,end=67) (ixx_cur(k),k=1,360)
	IF ((xlat.ge.glat).and.(xlat.lt.glat1)) THEN
C
C Interpolate to 2.5x5 grids
C	 
	do k=1,360
	XX(k)=IXX_pre(k)+(IXX_cur(k)-IXX_pre(k))*(glat-xlat)
	enddo
C
	ires(0)=nint(XX(1))
	ires(72)=nint(XX(360))
C
	xlon=0.0
	nout=0
	DO lon=5,359,5
	xlon=xlon+5.0
	nout=nout+1
	YY(nout)=XX(lon)+(XX(lon+1)-XX(lon))*0.5
	ires(nout)=nint(YY(nout))
	ENDDO
C	write(*,30) (ires(k),k=0,72)
	write(12,30) (ires(k),k=0,72)
	xlat=xlat+2.5
                                         ENDIF
	do kk=1,360
      IXX_pre(kk)=IXX_cur(kk)
	enddo
	ENDDO      ! end lati cycle
C
   66	CONTINUE
   67	close(unit=11)
      close(12)
  101	CONTINUE
C
   24	format(360(1X,I4))
   30 format(73(1X,I4))
	goto 33
    2	write(*,*) 'Error reading data file',infile
   33	continue
	pause ' '
   31	stop
	end


