      program gimmapvf
C..............................................................Apr. 2019
C
C............................................................. Dec. 26, 2018
C Add Vsigma(TEC) maps
C..............................................................Dec. 2018
C Add Vf maps from PRIME results
C..............................................................June  2018
C Produce GIM-WfoF2 maps in IONEX format
C
C..............................................................Aug. 2017
C Add producing GIM-Tau_global_mean => 'tauavYR.txt'
C Produce tau map in IONEX from JPL-GIM-TEC divided by PRIME_foF2_map
C Input:
C JPL GIM-TEC IONEX maps in geogr coords d:\web\dts\YR\MN\tcMNDYUT.jYR
C (1) PRIME foF2 IONEX maps in geogr coords d:\web\dfc\YR\MN\fcMNDYUT.pYR	
C (2) GIM_fcF2 derived by IRI-Plas from TEC-fit d:\web\dfs\YR\MN\fcMNDYUT.jYR	
c	  count Tau=TEC/NmF2, 
C (1) Output: tuMNDDUT.pYR => d:\web\dtt\YR\MN\	 !slab-thickness Tau_Prime map
C (2) Output: tsMNDDUT.jYR => d:\web\dtt\YR\MN\	 !slab-thickness Tau_TEC_fcF2 map
C Maps in geogr coord. glats -87.5:2.5:87.5 , Mlongs -180:5:180
C	   
      DIMENSION IM(12)
C	+,TEC(0:72),FF2(0:72)
C	+,TAUAV(0:23),ITAUAV(0:23) ! Tau-mean
C	INTEGER*4 IRES(0:72)
	CHARACTER*2 ayr,amn,ady
C	+,aut
	CHARACTER*4	AYMN,AYEAR
	CHARACTER*1 cc ! =p for PRIME, =c for TEC-fit fcF2 =s for TEC Vsigma 
     +,fhts !
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Test
C	infile='d:\web\dfv\YR\MN\wfmnddut.pYR'	 ! Wf Prime
Crem            cc='p' !TEMP  for PRIME_foF2 maps
            cc='s' !TEMP  for Vsigma(TEC) maps
Crem	fhts='p' !for Vf (PRIME) maps          
      fhts='v'  ! for Vf from TEC maps          
CvTEC      fhts='i'  ! for Vsigma (TEC) maps        
   1        WRITE(*,*)' ENTER yrmn (0000=stop):'
		READ(*,15) AYMN
	      WRITE(*,*)' ENTER idy1, idy2 :'
		READ(*,*) idy1,idy2
	AYR=AYMN(1:2)
C
	AMN=AYMN(3:4)
   14	FORMAT(A1)
   15	FORMAT(A4)
	if (aymn.eq.'0000') goto 2	   ! Stop program
C

	AYEAR(3:4)=AYR
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	if (iyr.lt.30) then
	iyyyy=2000+iyr
	AYEAR(1:2)='20'
	              else
	iyyyy=1900+iyr
	AYEAR(1:2)='19'
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
  199	format(A2)
C
C Day-to-day cycle
       read(AMN,*) rmn
	IMN=int(rmn)   ! current mn
       nmdy=im(imn)
C
	DO 200 idy=idy1,idy2
	call blet2(idy,ADY)
C
  159	format(73(1X,F4.1))
  162	format(73(1X,I4))
  163	format(1X,3A2,24(1X,I4))
C
C Produce daily file in JPL IONEX format
	call mapionexvs(fhts,ayear,amn,ady)
  200	CONTINUE  ! next day
	if (imn.lt.13) goto 1
    2    write(*,*) AYR,AMN
    	pause ' '
      STOP
	end