      program hmsealand
C................................................June 2016
C Extract hmF2 map 
C                     
C geogr.coords. IONEX grids 
C 
C Output: TECave(sea) and TECave(land) monthly mean
C
C ...............................................Jan. 2013
C extract from JPL-TEC map 
C
	CHARACTER*2 AYR,AMN
	CHARACTER*4 AYEAR
	CHARACTER*65 outfile0,outfile1,infile	! 0 ~ sea, 1 ~ land
	INTEGER*2 jyr,jmn
	logical lout
	DIMENSION tec(0:72),res0(12),res1(12)
C
  103	nn=1

	outfile0='hmseamn0.txt'
	outfile1='hmlanmn1.txt'
	OPEN(10,file=outfile0,access='APPEND')
	OPEN(11,file=outfile1,access='APPEND')
	do i=1,12
	res0(i)=0.
	res1(i)=0.
	enddo

C Read geogr. coords.
  102	format(73(1X,F4.0))
  101	format(1X,A4,4(1X,F6.1))
C
  111	write(*,*) 'enter AYEAR='
	read(*,*) AYEAR
	AYR=AYEAR(3:4)

	write(*,*) 'enter AMN='
	read(*,*) amn
C
      infile='hmMN0012.uYR'	  !SMF2 UT map
	infile(11:12)=AYR

C Cycle on mn:
	DO jmn=3,12,3
	call blet2(jmn,AMN)
	infile(3:4)=AMN
C
 	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
c	if(int(ryr/4.)*4.eq.jyr) THEN 
c 	im(2)=29
c	                          ELSE
c	IM(2)=28
c	ENDIF

c	jdy1=01
c	jdy2=im(jmn)
C
	tecmn0=0.
	tecmn1=0.
C 
C
C       
	OPEN(12,file=infile,action='READ')
C
C All lats 
	glat=-90.0
	cnt0=0.
	cnt1=0.
  110	DO 100 ilat=1,71
	glat=glat+2.5
	read(12,102,end=51,err=23) (tec(k),k=0,72) 
C
	glon=-185.
      	DO ilon=0,72 
	glon=glon+5.0
	if (glon.lt.0.) glon=glon+360.
C
	call sealand(glat,glon,lout)
	if (lout) then
	tecmn0=tecmn0+tec(ilon) ! sea
	cnt0=cnt0+1.
	          else
	tecmn1=tecmn1+tec(ilon) ! land
	cnt1=cnt1+1.
	endif
	   ENDDO
C
  100	continue ! End cycle on ilat
   51 close(unit=12)
  115	CONTINUE        ! End cycle on UT
c	write(*,*) ' DAY =',ADY
  120	CONTINUE        ! End day-to-day cycle
c	cnt0=cnt1*24.*jdy2
c	cnt1=cnt1*24.*jdy2
C-	cnt0=3226.*24.*float(jdy2)
c-	cnt1=1957.*24.*float(jdy2)
CREM	cnt0=3226. ! total sea grids
CREM	cnt1=1957. ! total land grids
	res0(jmn)=tecmn0/cnt0
	res1(jmn)=tecmn1/cnt1
	  ENDDO                ! end month-to-month cycle
	write(*,101)  AYEAR,res0(3),res0(6),res0(9),res0(12)
	write(10,101) AYEAR,res0(3),res0(6),res0(9),res0(12)
	write(*,101)  AYEAR,res1(3),res1(6),res1(9),res1(12)
	write(11,101) AYEAR,res1(3),res1(6),res1(9),res1(12)
C	if (AYR.ne.'13') goto 111
   23	write(*,*) AYR,AMN
	close(unit=10)
	close(unit=11)
   	pause ' '
	stop
	end