      program magmap
C.................................................................Nov 2015
C extract TEC in magnetic coordinated from JPL GIM-TEC
C Magnetil grids maps for mlats=-85,-80,...,85 (1 to 35 lines)
C                         mlongs=0,5,...,360 (0 to 72 cols.)
C
	DIMENSION IM(12)
	+,glatm(35,0:72),glonm(35,0:72)
	CHARACTER*65 inglats,inglons
		CHARACTER*2 AYR,AMN,ADY
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	common/BLMAG/glatm,glonm
C Read geogr. coords. for magn. grids
 	inglats='glatgrid.txt'
	inglons='glongrid.txt'
  101	format(73(1X,F5.1))
	OPEN(10,file=inglats)
	OPEN(11,file=inglons)
C

	do i=1,35
	read(10,101) (glatm(i,k),k=0,72)
	do k=0,72
	if (glatm(i,k).gt.87.5) glatm(i,k)=87.5
	if (glatm(i,k).lt.-87.5) glatm(i,k)=-87.5
	enddo
      read(11,101) (glonm(i,k),k=0,72)
	enddo
	close(unit=10)
	close(unit=11)
C
	WRITE(*,*)' ENTER YR OF INPUT FILE=	'
	read(*,17) AYR
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	if (iyr.lt.20) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
 199  WRITE(*,*)' ENTER MN'
	READ(*,13) IMN
   13 FORMAT(I2)
ctemp	idys=1           ! Cycle on day-to-day
	WRITE(*,*)' ENTER IDY1,IDY2'
	READ(*,13) IDYS,IDYS2
C>	idys=1
C>	idys2=im(imn)
 201	CONTINUE		 ! cycle on days
   17 format (A2)
 	call blet2(imn,amn)  ! current month
200   DO idy=idys,idys2	  
	call blet2(idy,ADY)


		call subexmag1(AYR,AMN,ADY)
	ENDDO
	if (imn.lt.12) goto 199
	pause ' '
	stop
	end