      program magmapc
C.................................................................Nov 2015
C extract TEC in magnetic coordinat from IRI-Plas-CCIR prediction GIM-TEC
C Magnetil grids maps for mlats=-85,-80,...,85 (1 to 35 lines)
C                         mlongs=0,5,...,360 (0 to 72 cols.)
C
	DIMENSION IM(12)
	+,glatm(35,0:72),glonm(35,0:72)
	CHARACTER*65 inglats,inglons
		CHARACTER*2 AYR,AMN,ADY
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	common/BLMAG/glatm,glonm
C Read geogr. coords. for magn. grids
 	inglats='glatgrid.txt'
	inglons='glongrid.txt'
  101	format(73(1X,F5.1))
	OPEN(10,file=inglats)
	OPEN(11,file=inglons)
C

	do i=1,35
	read(10,101) (glatm(i,k),k=0,72)
	do k=0,72
	if (glatm(i,k).gt.87.5) glatm(i,k)=87.5
	if (glatm(i,k).lt.-87.5) glatm(i,k)=-87.5
	enddo
      read(11,101) (glonm(i,k),k=0,72)
	enddo
	close(unit=10)
	close(unit=11)
C	IYR=57
      WRITE(*,*)' ENTER YR OF INPUT FILE=	'
	read(*,17) AYR
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
C
    1	continue
C>	iyr=iyr+1
	if (iyr.eq.16) GOTO 2
	if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,AYR)
C?	if (iyr.lt.20) then
C?	iyyyy=2000+iyr
C?	              else
C?	iyyyy=1900+iyr
C?	endif
	z1=iyr/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyr) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
	imn=1
 199  continue
C      WRITE(*,*)' ENTER MN'
C	READ(*,13) IMN
   13 FORMAT(I2)
ctemp	idys=1           ! Cycle on day-to-day
C>	WRITE(*,*)' ENTER IDY1,IDY2'
C>	READ(*,13) IDYS,IDYS2
	idys=0
	idys2=0
 201	CONTINUE		 ! cycle on days
   17 format (A2)
 	call blet2(imn,amn)  ! current month
C>200   DO idy=idys,idys2	  
  200 idy=0
C	call blet2(idy,ADY)
	ADY='00'

		call subexmag2(AYR,AMN,ADY)
C	ENDDO
	if (imn.lt.12) then
	imn=imn+1
      goto 199
C	else
C	iyr=iyr+1
C	goto 1
	endif 
   2	pause ' '
	stop
	end