      program maperr3
C..................................................................Feb.2016
C IONEX grids -87.5:2,5:87.5; -180:5:180;
C Relative error between 2 maps: tpMN00LT.jYR (J2 pTEC) & tpMN00LT.iYR (IRI-Plas pTEC)
C
C
	dimension ires(0:72),IXX(0:72),IYY(0:72),ZZ(0:72)
	CHARACTER*28 INFILE1,INFILE2,OUTFILE1,outfile2
	character*2 ayr,amn,alt
C
	infile1='ptmn00LT.jyr'
	infile2='ptmn00LT.iyr'
	outfile2='maperr2.txt'
	OPEN(10,file=outfile2,access='APPEND')
C
	WRITE(*,*) 'Enter AYR and AMN for input: '
	read(*,*) AYR,AMN
C
	read(ayr,*) yr
	iyr=int(yr)
	read(amn,*) rmn
	imn=int(rmn)

	write(*,23) ayr,amn
   23	format(3(1X,A2),4(1X,F7.4),1X,I6)
   24	format(1X,A12,1X,A12)
   25 format(A1)	 
	infile1(3:4)=amn
	infile1(11:12)=ayr
	infile2(3:4)=amn
	infile2(11:12)=ayr
  100	format(73(1X,F4.2))
  101	format(73(1X,I4))
  102	format(73(I5))
	write(*,24) infile1,infile2
	write(10,24) infile1,infile2
C
C day-to-day cycle
C LT-cycle Input for 00,04,...23 LT; 
	ii=0
	icnttot=0
	rmsetot=0.
	relerrtot=0.
	avexxtot=0.
	do 70 ilt=0,23
	call blet2(ilt,ALT)
	infile1(7:8)=alt
	 infile2(7:8)=alt
	outfile1=infile1
	outfile1(1:1)='d'
		OPEN(11,FILE=INFILE1)
		OPEN(12,FILE=OUTFILE1)
		OPEN(13,FILE=INFILE2)
C
	relerr=0.
	icnt=0.
	sum=0
	rmse=0.
	do kk=1,71
	read(11,101,END=9,ERR=2) (ixx(i),i=0,72)
	read(13,101,END=19,ERR=2) (iyy(i),i=0,72)
	do 20 k=0,72
	if (ixx(k).le.0) then
	ires(k)=0
	goto 20 !missed value
	endif
	xdat=ixx(k)/100.
	ydat=iyy(k)/100.
	zz(k)=(xdat-ydat)/xdat
	azz=abs(zz(k))
	if(azz.gt.2.) then
	azz=2.0
	  if (xdat.lt.ydat) then
	  ydat=3.*xdat
	  zz(k)=-2.
	  else
	  ydat=-xdat
	  zz(k)=2.
        endif	
	endif
	rmse=rmse+(xdat-ydat)**2
	icnt=icnt+1
	sum=sum+xdat
	ires(k)=nint(zz(k)*100.)
	relerr=relerr+azz
   20	continue
c	write(*,101) (ires(k),k=0,72)
		write(12,101) (ires(k),k=0,72)
	enddo			! end lats
C
    9	close(unit=11)
   19	close(unit=13)
      close(unit=12)
	if (icnt.eq.0) goto 125
	rmsetot=rmsetot+rmse
	icnttot=icnttot+icnt
	relerrtot=relerrtot+relerr
	avexxtot=avexxtot+sum
C
	rmse=sqrt(rmse/icnt)
	relerr=relerr/icnt  !REl ERR, TECU
	avexx=sum/icnt
	rmsen=rmse/avexx
  125	write(*,23) AYR,AMN,ALT,avexx,relerr,rmse,rmsen,icnt
	write(10,23) AYR,AMN,ALT,avexx,relerr,rmse,rmsen,icnt
   70	continue !
C Results for all LT maps:
		rmsetot=sqrt(rmsetot/icnttot)
	relerrtot=relerrtot/icnttot 
	avexxtot=avexxtot/icnttot
	rmstotn=rmsetot/avexxtot
	ALT='99'
	write(*,23) AYR,AMN,ALT,avexxtot,relerrtot,rmsetot,rmstotn
	+,icnttot
	write(10,23) AYR,AMN,ALT,avexxtot,relerrtot,rmsetot,rmstotn
	+,icnttot
	   close(unit=10)
	goto 33
    2	write(*,*) 'Error reading data file',infile1,infile2
   33	continue
	pause ' '
   31	stop
	end


