      program ptsealandq3
C................................................June 2016
C Global mean and STD
C
C Include weight Q for dependence of cell area on glats
C Add STD calculation
C
C Extract pTEC map : pjMN00LT.hyr (J2) ; piMN00LT.hyr (IRI-Plas-CCIR)
C                     
C geogr.coords. IONEX grids 
C 
C Output: pTECave(sea) and pTECave(land) monthly mean for LT=00, 01,...,23
C
C ...............................................Jan. 2013
C extract from JPL-TEC map 
C
	CHARACTER*2 AYR,AMN,RLT
	CHARACTER*4 AYEAR
	CHARACTER*65 outfile,infile	! 
	CHARACTER*1 ji
	DIMENSION tec(71,0:72),res(12)
C+	+,Q(71) ! weights*10
	+,std(12),aver(12),avstd(12)
C
C+      DATA Q/.0067443,.0134533,.0201528,.0268159,.0334247,.0399717,
C+	+ .0464414,  .0528289,  .0591099,  .0652797,  .0713261,  .0772395,
C+	+ .0830030,  .0886092,  .0940534,  .0993114,  .1043856,  .1092541,
C+	+ .1139244,  .1183770,  .1225998,  .1265905,  .1303368,  .1338486,
C+	+ .1370943,  .1400788,  .1428022,  .1452546,  .1474168,  .1493105,
C+	+ .1509128,  .1522346,  .1532637,  .1539977,  .1544452,  .1545900,
C+	+ .1544452,  .1539977,  .1532637,  .1522346,  .1509128,  .1493105,
C+	+ .1474168,  .1452546,  .1428022,  .1400788,  .1370943,  .1338486,
C+	+ .1303368,  .1265905,  .1225998,  .1183770,  .1139244,  .1092541,
C+	+ .1043856,  .0993114,  .0940534,  .0886092,  .0830030,  .0772395,
C+	+ .0713261,  .0652797,  .0591099,  .0528289,  .0464414,  .0399717,
C+	+ .0334247,  .0268159,  .0201528,  .0134533,  .0067443/
C 
  	nn=1

	outfile='ptseamn.txt'
	OPEN(10,file=outfile,access='APPEND')

C Read geogr. coords.
  102	format(73(1X,F4.2))
  101	format(1X,A2,4(1X,F6.2,1X,F6.3))
  103	format(1X,A4,1X,A1)
C
  111	write(*,*) 'enter AYEAR='
	read(*,*) AYEAR
	AYR=AYEAR(3:4)

	write(*,*) 'enter j, i, t  or 0 for stop:'
	read(*,*) ji
	if (ji.eq.'0') goto 23   ! stop
C
	write(10,103) AYEAR,ji
C//      infile='hmMN0012.uYR'	  !SMF2 UT map
            infile='d:\web\dtc\YR\MN\pjMN00LT.hYR'
	infile(19:19)=ji
	infile(12:13)=AYR
	infile(28:29)=AYR
	do i=1,12
	res(i)=0.
	aver(i)=0.
	avstd(i)=0.
	enddo
C Cycle on LT:
      DO 115 lt=0,23
	call blet2(lt,RLT)
      infile(24:25)=RLT

C Cycle on mn:
	DO jmn=3,12,3
	call blet2(jmn,AMN)
	infile(15:16)=AMN
	infile(20:21)=AMN
C
 	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
C
	tecmn=0.
C
C       
	OPEN(12,file=infile,action='READ')
C
C All lats 
	glat=-90.0
	cnt=0.
  110	DO 100 ilat=1,71  !++++++++++++++++++++++++++++++++++++
	glat=glat+2.5
	read(12,102,end=51,err=23) (tec(ilat,k),k=0,72) 
C
	glon=-185.
      	DO 77 ilon=0,72 	   !>>>>>>>>>>>>
	glon=glon+5.0
	if (glon.lt.0.) glon=glon+360.
C
	if (tec(ilat,ilon).lt.0.) goto 77
C+	tecmn=tecmn+tec(ilat,ilon)*Q(ilat)*10. ! global
C+	cnt=cnt+Q(ilat)*10.
	tecmn=tecmn+tec(ilat,ilon) ! global
	cnt=cnt+1.

   77	CONTINUE  ! End cycle on ilon
C
  100	continue ! End cycle on ilat
   51 close(unit=12)
c	write(*,*) ' DAY =',ADY
c	cnt0=cnt1*24.*jdy2
c	cnt1=cnt1*24.*jdy2
C-	cnt0=3226.*24.*float(jdy2)
c-	cnt1=1957.*24.*float(jdy2)
CREM	cnt0=3226. ! total sea grids
CREM	cnt1=1957. ! total land grids
	res(jmn)=tecmn/cnt
C
C Add std calculation
C
	stdmn=0.
	cntstd=0.
	glat=-90.0
	DO 112 ilat=1,71  !++++++++++++++++++++++++++++++++std
	glat=glat+2.5
C
	glon=-185.
      	DO 177 ilon=0,72 	   !>>>>>>>>>>>>
	glon=glon+5.0
	if (glon.lt.0.) glon=glon+360.
	if (tec(ilat,ilon).lt.0.) goto 177
C+	stdmn=stdmn+(tec(ilat,ilon)*Q(ilat)*10.-res(jmn))**2. ! global
C+	cntstd=cntstd+Q(ilat)*10.
	stdmn=stdmn+(tec(ilat,ilon)-res(jmn))**2. ! global
	cntstd=cntstd+1.

  177	CONTINUE  ! End cycle on ilon
C
  112	continue ! End cycle on ilat
	std(jmn)=sqrt(stdmn/cntstd)
c	aver(jmn)=aver(jmn)+res(jmn)
c	avstd(jmn)=avstd(jmn)+std(jmn)
	  ENDDO                ! end month-to-month cycle
	write(*,101)  RLT,res(3),std(3),res(6),std(6),res(9),std(9)
	+,res(12),std(12)
CREM	write(10,101) RLT,res(3),std(3),res(6),std(6),res(9),std(9)
CREM	+,res(12),std(12)
 	do kk=3,12,3
 	aver(kk)=aver(kk)+res(kk)
 	avstd(kk)=avstd(kk)+std(kk)
	enddo
  115	CONTINUE        ! End cycle on LT
	do imn=3,12,3
	aver(imn)=aver(imn)/24.
	avstd(imn)=avstd(imn)/24.
	enddo
	write(*,101) RLT,aver(3),avstd(3),aver(6),avstd(6)
	+,aver(9),avstd(9),aver(12),avstd(12)
	write(10,101) RLT,aver(3),avstd(3),aver(6),avstd(6)
	+,aver(9),avstd(9),aver(12),avstd(12)
	 goto 111
   23	write(*,*) AYR,AMN
	close(unit=10)
	close(unit=11)
   	pause ' '
	stop
	end