C........................................................Feb. 2015
C
C Interpolate (hour+30 min) maps 2 x 2 deg. to (hour) maps 00, 01,...,23 h UT
C           input file web/dtt/YY/MM/ttMMDDUT30.eYY & UT30_pre
C  jprg  => output file web/dtt/YY/MM/ttMMDDUT00.eYY
C         lati: -90.0,-88.0,...,0,...,88.0,90.0 ==> i=1,2,...91
C         longi:-180.0, -178.0,... 0...178.0 ==> j=0,...,179
C output <jhrgDDD0.iYR>
C 
      PROGRAM techrs2x2
C----------------------------------------------------------------
C Select NEW+++:output 91 geographic latitudes: res1=90.0, 88.0,86,,.0..-90.0N 
C at: NEW+++: 0,1,...,91 geographic longitudes [-180,-178,...,178] = IONEX1 x 2 step
C Produce results for 0, 1,..., 23hr UT.iyr ~ 0.5, 1.5, ..., 23.5 hr UT 
C send results to d:/web/graf/dtr/YY/MM/trMMDDUT.jYY
C
C program for EXTRACTING FROM "JPRGdoy0.iYR" ionex1_TEC data 
C +++++++++
C
C*********TEST
      dimension glats(91),glons(0:179),itec_cur(0:179)
	+,itec_pre(0:179)
      integer itec(0:179)
C**********TEST
      CHARACTER*128 INFILE,INFILE_pre,OUTFILE
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 AYEAR
	CHARACTER*2 AYR,AYR_pre,AMN,AMN_pre,ADY,ADY_pre,AUT,AUT_pre
	dimension im(12)

	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C++
C
	glat=92.
	DO i=1,91
	glat=glat-2.0
	glats(i)=glat
	ENDDO
C
	glon=-182.
	do i=0,179
	glon=glon+2.0
	glons(i)=glon
	enddo
C++
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C cycle on year
C	AYEAR=DD(1:4)                  !               
	write(*,*) ' Enter YEAR: '
	read(*,118) AYEAR
	write(*,*) AYEAR
		AYR=ayear(3:4)
	read(ayr,*) ryr
	iyr=int(ryr)
	read(ayear,*) xyear
	IYYYY=int(xyear)
	iyr_pre=iyr
C following comands for month
		WRITE(*,*) 'Enter AMN for input: '  !
	 	read(*,*) AMN					   !
C	AMN=DD(5:6)               !
	write(*,*) amn

	read(amn,*) xmn
	imn=int(xmn)
	imn_pre=imn
C

		if(int(ryr/4.)*4.eq.iyr) THEN 
	IM(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
  987	format(I2)

C  data-DAY
C		WRITE(*,*) 'Enter dy for input: '  !
C	 	read(*,*) idy					   !
C
		infile='d:\web\dtt\YR\MN\ttMMDDUT30.eYR'	!
	infile_pre=infile
	infile(12:13)=ayr					 !
	infile(30:31)=ayr					 !
	infile(15:16)=amn					 !
		infile(20:21)=amn					 !
C
	outfile='d:\web\dtt\yy\mn\ttMNDYUT00.eYR'
	outfile(12:13)=AYR						 !
		 outfile(15:16)=AMN					 !
		 outfile(30:31)=AYR					 !
	outfile(20:21)=AMN					 !
C
      mndy=im(imn)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C daily cycle
C
  	DO 40 idy=1,mndy
      call blet2(idy,ady)
C	
	infile(22:23)=ady					 !
	outfile(22:23)=ADY						 !
C
	write(*,199) ayr_pre,amn_pre,ady_pre,aut_pre,ayr,amn,ady,aut !TEMP
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  UT cycle
C
	IRUN=0 ! 
      DO 41 iut=0,23 ! 
      call blet2(iut,AUT)
	infile(24:25)=aut					 !
	outfile(24:25)=AUT
	iyr_pre=iyr
	imn_pre=imn
	idy_pre=idy	
	iut_pre=iut-1
C
	if (iut_pre.lt.0) then	!+++
	iut_pre=23
	idy_pre=idy-1
C
	if (idy_pre.eq.0) then	!++
	imn_pre=imn-1
C
      if (imn_pre.eq.0) then  !+
	iyr_pre=iyr-1
	imn_pre=12
	endif					!+
C
	idy_pre=im(imn_pre)
      endif					!++

	endif                     !+++
	call blet2(iyr_pre,ayr_pre)
	call blet2(imn_pre,amn_pre)
	call blet2(idy_pre,ady_pre)
	call blet2(iut_pre,AUT_pre)
C
 	infile_pre(12:13)=ayr_pre					 !
 	infile_pre(30:31)=ayr_pre					 !
 	infile_pre(15:16)=amn_pre					 !
	infile_pre(20:21)=amn_pre					 !
	infile_pre(22:23)=ady_pre					 !
	infile_pre(24:25)=aut_pre					 !
C

  118	format(A4)
cc	pause  ' '
C
C =========================================
C output tec for -180, -178,...00,02,...,178 deg.E
	do i=1,91
	itec(i)=0	! output TEC lat x long (2 x 2) array 
	enddo
c
  198 format(1X,A39,1X,A39)
	OPEN(11,FILE=INFILE,ACTION='READ') ! TEC input for UT+30 min
	OPEN(10,FILE=INFILE_pre,ACTION='READ') ! TEC input for UT-30 min
	OPEN(12,FILE=OUTFILE) !TEC results   !
CC
CREM	write(*,199) ayr_pre,amn_pre,ady_pre,aut_pre,ayr,amn,ady,aut !TEMP
  199	format(8(1X,A2))
C++
C INPUT-OUTPUT OF RESULTS
	glat=-92.
	DO nnlat=1,91		!Output for glats=-90.0,88,..., 90.0
	glat=glat+2.0
	read(10,182,end=32,err=2) (itec_pre(k),k=0,179)
	read(11,182,end=33,err=2) (itec_cur(k),k=0,179)
C
	do k=0,179
	itec(k)=nint((itec_pre(k)+itec_cur(k))/2.)
	enddo
C	write(*,182) (itec(k),k=0,179)  !Test
	write(12,182) (itec(k),k=0,179)
	ENDDO                   ! lats cycle
C
  32		close(unit=10)
  33		close(unit=11)
  		close(unit=12)
   41 CONTINUE    !   End calculation for given UT

   40 CONTINUE    !     Daily cycle


 182	format(180(1X,I4))							
C
C Continue to the next UT hr :
C++++++++++++++++++++++++++++
C
C 
		goto 34	   ! end of calculations
C
c	write (*,888) alat,alon,aday
c  888	format(1X,' alat=',A3,' alon=',A3,' day=',A3)

    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 35

   34 CONTINUE
   35      write(*,*) infile,infile_pre,outfile
	write(*,*) irun
C temp
C	idy=idy+1
C	if (idy.le.im(imn)) then
C	goto 255
C	endif
      pause ' ' 
      STOP
       END

C***********************************************************
C
      subroutine submmdd(lda,iyr,imn,idy)
C To define imn & idy using iyr & lda=day-of-year
C
	       DIMENSION IM(0:12)
	integer*2 iyr,imn,idy,nyr,ii
	DATA IM/31,31,28,31,30,31,30,31,31,30,31,30,31/
	nyr=iyr
	imn=0
	idy=0
	z1=nyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.nyr) THEN
               IM(2)=29
	ndyr=366
        ELSE
                IM(2)=28
	ndyr=365
	       ENDIF
C Day-of-year = LDA
c//	write(*,*) lda
c//	pause ' '
C Define imn & idy
C NEW++++++++++++++++++++
	mosum=0
         do 1234 ii=1,12
	ndsum=mosum
	mosum=mosum+im(ii)
	imn=ii
	if (lda.le.mosum) then
	idy=lda-ndsum
	 goto 33
	exit
	endif
1234    continue
 33     continue
	RETURN
	END 
C ===============================================================
C ===========================================================
	subroutine SUBTREAD1(nn,yy)
C                                                             ! June 2015   
C
C   EXTRACT TEC FROM IONEX1 format to array yy(glat,glon) relevant to IONEX format
c
C
C
c
      DIMENSION txx(0:179),yy(91,0:179),xxx(16)
	character*60 txt

  90	format(3X,F5.1,A60)
180	format(16(1X,F4.0))
179	format(4(1X,F4.0))

c-	do j=1,3
	do k=0,179
	txx(k)=0.
	enddo
c-	enddo
	alat=92.	! resuts alat
	glat1=92.
	trem=20.

C===

	DO 20 ii=1,91 ! cycly on output lats
	alat=alat-2.0
   10	read(nn,90,err=2,end=9) glat,txt
	glat2=glat
C
	do j=1,11
	j1=(j-1)*16
    1	READ (nn,180,END=9,ERR=2) (xxx(i),i=1,16)
	do k=1,16
	if ((xxx(k).le.0.).or.(xxx(k).gt.9990.)) then
	if (txx(j1+k-1).gt.0.) then
	xxx(k)=txx(j1+k-1)	! replace wrong TEC
	                          else
	xxx(k)=trem ! replace wrong TEC
	endif
	                                       endif
	txx(j1+k-1)=xxx(k)
	trem=xxx(k)
	enddo
	enddo
	 READ (nn,179,END=9,ERR=2) (xxx(i),i=1,4)
		do k=1,4
	if ((xxx(k).le.0.).or.(xxx(k).gt.9990.)) then
	if (txx(j1+k-1).gt.0.) then
	xxx(k)=txx(175+k)	! replace wrong TEC
	                          else
	xxx(k)=trem ! replace wrong TEC
	endif
	                                       endif
	txx(175+k)=xxx(k)
	trem=xxx(k)
	enddo
c-	if ((alat.le.glat1).and.(alat.gt.glat2)) then
c-	rat=(glat1-alat)/2.
c-      do k=0,179
c-	txx(3,k)=txx(1,k)+(txx(2,k)-txx(1,k))*rat
c-	txx(1,k)=txx(2,k)
c-	enddo
	glat1=glat2
C Interpolate in longi
	alon=-182.
c-      alon=-180.
c-	glon1=-182.
c-	jout=0
crem	DO jj=0,71 ! cycle on output longs
	DO jlon=0,179 ! cycle on intput longs
	alon=alon+2.
c-   27	glon2=glon1+2.
	yy(ii,jlon)=txx(jlon)
crem	jg1=jg1+1
c-	if ((alon.ge.glon1).and.(alon.lt.glon2)) then
c-	yy(ii,jout)=txx(3,jlon)+(txx(3,jlon+1)-txx(3,jlon))*(alon-glon1)/2.
c-	glon1=glon2
c-	alon=alon+5.
c-	jout=jout+1
c-	endif 
c-	 glon1=glon2
   	ENDDO
c-	yy(ii,72)=yy(ii,0)
c-	                        else
c-	glat1=glat2
c-	do k=0,179
c-	txx(1,k)=txx(2,k)
c-	enddo
c-	goto 10
c-	endif
   20	continue
	goto 22
C ============================================	
    9	write(*,*) ' end of file'
	pause ' '
	goto 22
    2	write(*,*) ' error in input file'
 	pause ' '
C
   22 continue
	return
	end
C
C ===============================================================
