      program tsealand4
C................................................Aug. 2014
C Limit Data only if 'symmetric' value on the same sea/land
C
C extract from monthly median TECm, foF2m, hmF2m
C nighttime: 22, 23, 24(0), 25(1), 26(2) hrs LT
C daytime: 10, 11, 12, 13, 14 hrs LT
C
C................................................June 2014
C Extract JPL TEC map 
C                     
C geogr.coords. 
C 
C Output: TECave(sea) and TECave(land) monthly mean
C
C ...............................................Jan. 2013
C extract from JPL-TEC map 
C
	CHARACTER*2 AYR,AMN,AUT
c-	+,ADY
	CHARACTER*1 fht,dn
	CHARACTER*65 outfile0,outfile1,infile	! 0 ~ sea, 1 ~ land
	INTEGER*2 jyr,jmn,jut
c-	+,jdy1,jdy2,jdy
	logical lout,loutcp
	DIMENSION tec(0:72),res0(12),res1(12)
c-	+,im(12)
c-	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	write(*,*) 'Enter f, h or t :'
	read(*,99) fht
	write(*,*) 'Enter d (day) or n (night) :'
 	read(*,99) dn

	if (dn.eq.'d') then
	lt1=10
	lt2=14
	else
	lt1=22
	lt2=26
	endif

   99	format(A1)
  103	nn=1

	outfile0='tseamnc0.txt'		!

	outfile1='tlanmnc1.txt'
	OPEN(10,file=outfile0,access='APPEND')	  ! ocean
	OPEN(11,file=outfile1,access='APPEND')	  ! land
	write(*,99) fht,dn
	write(10,99) fht,dn
	write(11,99) fht,dn
	do i=1,12
	res0(i)=0.
	res1(i)=0.
	enddo

C Read geogr. coords.
  102	format(73(1X,F4.1))
  101	format(1X,A2,12(1X,F6.1))
C
	iyr=98
  111	iyr=iyr+1
	 if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,ayr)
c      write(*,*) 'enter AYR='
c	read(*,*) AYR

c-	write(*,*) 'enter AMN='
c-	read(*,*) amn
	infile='d:\web\dts\YR\MN\tcMN00UT.mYR'
	infile(9:9)=fht
	infile(18:18)=fht
	infile(12:13)=AYR
	infile(28:29)=AYR

C Cycle on mn:
	DO jmn=1,12
	call blet2(jmn,AMN)
c-	write(*,*) 'enter idy1,idy2='
c-	read(*,*) jdy1,jdy2
C
 	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
c-	jmn=int(rmn)
c//	if(int(ryr/4.)*4.eq.jyr) THEN 
c// 	im(2)=29
c//	                          ELSE
c//	IM(2)=28
c//	ENDIF

c//	jdy1=01
c//	jdy2=im(jmn)
C
	infile(15:16)=AMN
	infile(20:21)=AMN
	tecmn0=0.
	tecmn1=0.
C 
C
C Day-to-day cycle
c//	do 120 jdy=jdy1,jdy2
c//	call blet2(jdy,ADY)
c//	infile(22:23)=ADY
C       
	cnt0=0.
	cnt1=0.
C Cycle on UT
	do 115 jut=0,23
	call blet2(jut,AUT)
	infile(24:25)=AUT
		OPEN(12,file=infile,action='READ')
C
C All lats 
	glat=-90.0
  110	DO 100 ilat=1,71
	glat=glat+2.5
	read(12,102,end=51,err=23) (tec(k),k=0,72) 
C
	glon=-185.
      	DO 90 ilon=0,72 
	glon=glon+5.0
	if (glon.lt.0.) glon=glon+360.
	if (fht.eq.'h') tec(ilon)=tec(ilon)*10.
	hour=jut+glon/15.
	if (hour.gt.24.) hour=hour-24.
	if (hour.le.2.) hour=hour+24.
	lt=nint(hour)
	if ((lt.lt.lt1).or.(lt.gt.lt2)) goto 90

C
	call sealand(glat,glon,lout)
	glat1=glat*(-1.)
	call sealand(glat1,glon,loutcp)
crem	if (lout) then
	if (lout.and.loutcp) then
	tecmn0=tecmn0+tec(ilon) ! sea
	cnt0=cnt0+1.
	endif
crem	          else
	if ((.not.lout).and.(.not.loutcp)) then
	tecmn1=tecmn1+tec(ilon) ! land
	cnt1=cnt1+1.
	endif
crem	endif
c-	   ENDDO
   90	CONTINUE
C
  100	continue ! End cycle on ilat
   51 close(unit=12)
  115	CONTINUE        ! End cycle on UT
c	write(*,*) ' DAY =',ADY
  120	CONTINUE        ! End day-to-day cycle
c	cnt0=cnt1*24.*jdy2
c	cnt1=cnt1*24.*jdy2
c?	cnt0=3226.*24.*float(jdy2)
c?	cnt1=1957.*24.*float(jdy2)
	res0(jmn)=tecmn0/cnt0
	res1(jmn)=tecmn1/cnt1
	  ENDDO                ! end month-to-month cycle
	write(*,101)  AYR,(res0(k),k=1,12)
	write(10,101) AYR,(res0(k),k=1,12)
	write(*,101)  AYR,(res1(k),k=1,12)
	write(11,101) AYR,(res1(k),k=1,12)
	if (IYR.eq.99) goto 111
	if (IYR.lt.13) goto 111
   23	write(*,*) AYR,AMN
	write(*,89) cnt0
	write(10,89) cnt0
	write(*,89) cnt1
	write(11,89) cnt1
   89	format(1X,F7.0)
	close(unit=10)
	close(unit=11)
   	pause ' '
	stop
	end