C........................................................Apr.2017
C add extract W-index maps for UT=0,...,23
C........................................................Dec.2012
C Gulyaeva Tamara <gulyaeva@izmiran.ru>
C
C Extract maps foF2, hmF2, TEC, from daily JPL-IONEX file
      PROGRAM EXTMAPWJ
C----------------------------------------------------------------
C Select :Input 71 geographic latitudes: res1=87.5,85,,.0..-87.5N 
C at: 0,1,...,72 geographic longitudes [-180,-175,...,180] = IONEX step
C Produce maps fc (foF2),  hc (hmF2), tc (TEC) for 0, 1,..., 23hr UT.syr  
C
C*********TEST
	 integer ifcf2(71,0:72),IM(12)
	CHARACTER*2 AYR,AMN,DY1,DY2
	CHARACTER*3 DOY
	character*1 gh,cc		! indicator = f(for fc), h(hc), or t(tc(), w(wc)
C cc='a','b','c'
	DIMENSION GLATS(71),GLONS(0:72)
	 INTEGER*2 iyr,imn,idy,nndy,iut,ndyend
	+,iut0
C**********TEST
      CHARACTER*128 INFILE,outfile

	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 AYEAR,RYEAR
	CHARACTER*60 txt
	character*2 rmn,rdy,ady,ady0,RUT
	character*16 start,txt1
	integer*4 ixx(16)
	dimension itxx(0:72)
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
      WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
      READ(*,'(A)') AYEAR
C	AYEAR='2018' !temp
	write(*,*) ' Year=',AYEAR
	read(ayear,*) xyear
	IYYYY=int(xyear)
		ayr=ayear(3:4)
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	z1=iyr/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyr) THEN
               IM(2)=29
	dnr=366.
      ndnr=366
	  ELSE
                IM(2)=28
	  	dnr=365.
	ndnr=365
	       ENDIF
C
C      WRITE(*,'(\A\)') ' ENTER f, h, t or w for INPUT FILE='
C      READ(*,'(A)') gh
C      WRITE(*,'(\A\)') ' ENTER a, or b, or c for INPUT/output FILE='
C      READ(*,'(A)') cc
      cc='c'     
	gh='t'
ctemp	gh='w'
C
	glat=-90.
	DO i=1,71
	glat=glat+2.5
	glats(i)=glat
	ENDDO
C
	glon=-185.
	do i=0,72
	glon=glon+5.0
	glons(i)=glon
	enddo
C
C      WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
C      READ(*,'(A)') AMN
        DO 150 imn=1,12
	call blet2(imn,AMN'
C	AMN='04' ! temp
	write(*,*) ' MN=',AMN

C		WRITE(*,*) 'Enter ndy1, ndy2 for input: '
C 	read(*,987) nndy,ndyend
  987	format(I2)
C?	call blet2(nndy,DY1)
C?	call blet2(ndyend,DY2)
C?	ady0=DY1
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C
	IRUN=0 ! NORMAL COMMAND
	iut0=0 ! NORMAL COMMAND
C
crem		start='START OF W-index MAP'
       if (gh.eq.'t') then
	start='START OF TEC MAP'
	endif
	 if (gh.eq.'f') then
	start='START OF foF2 MAP'
	endif
	 if (gh.eq.'h') then
	start='START OF hmF2 MAP'
	endif
	 if (gh.eq.'w') then
	start='START OF W-index MAP'
	endif
	infile='d:\web\graf\dtc\yr\mn\ut\tcmndyut.jyr' 
C	infile='d:\web\graf\dfc\yr\mn\yrmndyf.txt'  ! ionex type daily file
crem	infile='d:\utec\YEAR\jplgDOY0.YRi'  ! ionex type daily file
crem	infile='d:\utec\YEAR\jhrgDOY0.YRi'  ! ionex type daily file
C>>	outfile='d:\web\dfs\yr\mn\fcmndyut.jyr'  ! one map file
	outfile='d:\web\graf\dwc\yr\mn\ut\wcmndyut.jyr'  ! one map file
	infile(14:14)=gh
	infile(26:26)=gh
c	if (cc.eq.'c') then 
c	infile(33:33)='t'
c	else
c	infile(33:33)=cc
c	endif
crem	infile(9:12)=ayear
	infile(17:18)=ayr
	infile(20:21)=amn
	infile(28:29)=amn
	infile(36:37)=ayr
crem	infile(23:24)=ayr

C	outfile(14:14)=gh
C	outfile(26:26)=gh
C      outfile(27:27)=cc

	outfile(17:18)=ayr
	outfile(20:21)=amn
	outfile(28:29)=amn
	outfile(36:37)=ayr

  118	format(A4)
cc	pause  ' '
C
C =========================================
c
       ndmn=im(imn)
	DO 151 idy=1,mdmn
CC
  199	format(' day=',A2)

C	read(dy1,*) xdy
C	idy1=int(xdy)
C	read(dy2,*) xdy2
C	idy2=int(xdy2)

c outfiles =================================
C	idy=idy1
  80	call blet2(idy,ADY)
	write(*,199) ady
	outfile(30:31)=ady
	 lda=ndoy(iyr,imn,idy)
	call blet3(lda,DOY)
c//	infile(19:20)=ady
crem      infile(18:20)=DOY
	   infile(30:31)=ady
C++
       DO iut=0,23
	call blet2(iut,AUT)
	infile(32:33)=aut
      	outfile(32:33)=aut
C
	OPEN(111,FILE=INFILE,ACTION='READ')

c   	do i=1,1200					             !!
c	READ (111,187,END=33,ERR=2) txt,txt1
c  187	format(A60,A16)
c	if (txt1.eq.start) goto 88
c	enddo									 !!
c  88	continue

C
c   11	continue     ! day-to-day cycle >>>>>>>>>>>>>>>
C
c   27 format(A60)

C
c ***************************************************************
D start cycle on hr-to-hr input:

C Start of reading VTEC, or foF2, or hmF2 for UT ========================
c  700 	read (111,89,end=9,err=85) ryear,rmn,rdy,rut
CADD++++++++++++++++++++++++++++++++++++++++++++++++
c	if (rut(1:1).eq.' ') rut(1:1)='0'
c	read(rut,*) xut
c	iut=int(xut)
c	outfile(32:33)=rut

C   89 format(2X,A4,4X,A2,4X,A2,4X,A2)

C   85	continue
      write(*,89) ryear,amn,rdy,rut
	

C
C Start input for given UT:++++++++++++++++++++
C
C =========================================
C
C	jt=0
C
C 
C  	ilat=0
C start cycle on glatitudes:
	glati=-90.0
C	nnlat=72
C
	DO 777 lat=1,71	   ! Start cycle on glati ++++++++++++++++++++++++++++++++
		ilat=ilat+1   ! ilat=1 for 87.5
	glati=glati+2.5
	ALATI=glati        ! for iriplas
	 
c   77	DO kl=1,72                 ! cycle on latitudes
C   87	read (111,90,end=9,err=2) glat,txt
C   90	format(2X,F6.1,A60)
C  91   	j1=0
C
C
C	do lon=0,72        
C	j1=(j-1)*16
   1	READ (111,180,END=9,ERR=2) (ifcf2(lat,i),i=0,72) ! TEC(lon)
  180	format(73(1X,I4))
c	do k=1,16
crem	if (ixx(k).le.0) ixx(k)=20
C	itxx(j1+k-1)=ixx(k)
C	enddo
C	enddo			  ! end longitudes
C	READ (111,179,END=9,ERR=2) (ixx(i),i=1,9)
C  179	format(9(1X,I4))
C	do k=1,9
crem	if (ixx(k).le.0) ixx(k)=20
C	itxx(63+k)=ixx(k)
C	enddo
CC
C	nnlat=nnlat-1  ! Keep results for GLAT=87.5(-87.5) at nnlat=71(1)
C	do kk=0,72
C	ifcf2(nnlat,kk)=itxx(kk)
C	enddo
C Select values for Long=-180,-165,...0,15,30,..,165,180!!!!!!!!!!!!:
C
C	ii=-1
C	 jj=71
C====================================================
c//	write(*,181) iut,ALATI
  777	continue   ! End cycle of reading all GLATs
   9	close(unit=111)
C  181 format(2X,I2,2X,F5.1)
C
C ==================================================
C
C --------------- 
C Prepare output of results for nnlong=0,1,...,24

		OPEN(12,FILE=OUTFILE)
C	DO nnlat=1,71
C		write(12,182) (ifcf2(nnlat,k),k=0,72)
C	ENDDO
 182	format(73(1X,I4))							
	close(unit=12)
	if (iut.lt.24) then
	READ (111,187,END=33,ERR=2) txt,txt1
crem	READ (111,187,END=33,ERR=2) txt,txt1
	if (txt1.eq.start) then
	goto 11
	else
	goto 33
	endif
	endif
	 
DD  775 continue   ! End calculation for given UT
C
    9	continue
C Continue to the next UT hr :
  32		irun=irun+1 
C

C 
   33	close(unit=111)

  101 idy=idy+1
	irun=0
c	pause ' '
	if ((idy.le.idy2).and.(idy1.lt.idy2)) then
	goto 80
	else
		goto 35	   ! end of calculations
	endif
C
    2 CONTINUE
      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 35
      endif

   35      write(*,*) infile,outfile
	write(*,*) irun
C temp
      pause ' ' 
      STOP
       END

C***********************************************************
