C					                                  May 2016
C  Extract monthly mean map pTEC 
C    from maps pTEC(LT) in geomag lat [-87.7:87.5], geogr. long.[-180 180] 
C    for LT=0,1,...,24 hrs 
C output array: x=00, 01, ...,24LT, y=pTEC(mlats -60:2.5:60)
C    
      program extrmapmlatlt
C
      DIMENSION im(12),da(71,0:72),pec(49,0:72)
	+,gmlats(49,0:72),res(49,0:24)

      character*2 ayr,amn,aut
	character*1 pt
	character*45 infile,outfile,infilemlat
	character*4 AYEAR

	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/

c Input array of mlats at glongs:
	infilemlat='glonglt1.txt'
	OPEN(10,file=infilemlat,action='READ')
	do lat=1,49
	read(10,41,end=30) (gmlats(lat,k),k=0,72)
	enddo
   30	close(unit=10)
   41 format(73(1X,F5.1))
C
c Add input of fm:
       write(*,*) 'ENTER j, t, r or i:'
	 read(*,*) pt
   31    write(*,*) 'ENTER YEAR:'
	 read(*,*) AYEAR
	AYR=AYEAR(3:4)
       write(*,*) 'ENTER MN or 00 for stop:'
	 read(*,*) AMN
		read(ayr,*) yr
		read(amn,*) rmn
	imn=int(rmn)
	if (imn.eq.0) goto 33
C
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	ndnr=im(imn)
C
C 
C
       infile='d:\web\dtc\yy\mm\pjmm00lt.hyr'
	infile(19:19)=pt
	infile(12:13)=ayr
	infile(28:29)=ayr
	infile(15:16)=amn
	infile(20:21)=amn
	outfile='d:\web\dtc\yy\mm\pjYRMMmlat.tlt'	  !monthly aver gmlat x LT 
	outfile(19:19)=pt
	outfile(12:13)=ayr
	outfile(20:21)=ayr
	outfile(15:16)=amn
	outfile(22:23)=amn
	OPEN(11,FILE=outfile)
C
C

C
   18	continue
	do i=1,49
	do k=0,24
	res(i,k)=0.
	enddo
	do k=0,72
	pec(i,k)=0.
	enddo
	enddo

  202 format(A60)
C
C cycle	LT
      do 203 ilt=0,23
	call blet2(ilt,aut)
	infile(24:25)=aut
C
      OPEN(111,FILE=INFILE,action='READ')
C
  107 format(73(1X,F4.0))	! 
C
	do lat=1,71               !start reading mlats
	READ (111,107,END=99,ERR=2) (da(lat,k),k=0,72) !map lines
	enddo				   ! end mlats
   99	close(unit=111)
C
C
C select pTEC at gmlat for each glong:
	            DO lon=0,72    !all longs
C
	gmlat=-62.5
          DO mlat=1,49           !gmlats
	gmlat=gmlat+2.5
C
	glat=-90.
	do lat=1,70				   ! lats
	glat=glat+2.5
	if ((gmlat.ge.glat).and.(gmlat.lt.glat+2.5)) then
C chech missed pTEC J2:
                 if (pt.eq.'j') then      !<<<<<<<<<<<<<<<<
	if (lat.lt.25) then
	istep=1
	else
	istep=-1
	endif
  25	                if (da(lat,lon).lt.0.) then  !++++++++
	if (da(lat+istep,lon).gt.0.) then
		da(lat,lon)=da(lat+istep,lon)
	goto 26
	         else
	istep=istep*2
	goto 25
	endif
	                  endif					   !++++++++

  26	if (da(lat+1,lon).lt.0.) da(lat+1,lon)=da(lat,lon)
	                                    endif	 !<<<<<<<<<<<<<<<<
C
	ptec=da(lat,lon)+(da(lat+1,lon)-da(lat,lon))/2.5*(gmlat-glat)
	 pec(mlat,lon)=pec(lat,lon)+ptec   !map gmlat [-60:60] x glong [-180:180]
C	res(mlat,ilt)=res(mlat,ilt)+pec(mlat,lon)   !map gmlat [-60:60] x LT [0:24]
	res(mlat,ilt)=res(mlat,ilt)+ptec   !map gmlat [-60:60] x LT [0:24] (73 values per mlat line)
	exit
	endif
	enddo					   ! lats
	    ENDDO				   !gmlats
	            ENDDO       ! all longs
 203  CONTINUE				  ! end hour-to-hour LT cycle
C
C output results for UT:
	do mlat=1,49
C
      do lt=0,23
	res(mlat,lt)=res(mlat,lt)/7300. !TECU
	enddo
C
	res(mlat,24)=res(mlat,0)
	write(*,108) (res(mlat,k),k=0,24)
	write(11,108) (res(mlat,k),k=0,24)
		enddo

  108 format(25(1X,F5.2))	! 
      close(unit=11)
	write(*,*) infile,outfile
C
c+       GOTO 33
       GOTO 31         ! next mn
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
   33	continue
      write(*,*) infile,outfile
      pause ' ' 
   34   STOP
       END

