      program extrptec
C.................................................................Feb 2016
C extract/interpolate pTEC from IRI-Plas5 files produced by I.Zakharenkova
C LocalTime grids maps in IONEX grids for glats=-87.5,-85,...,85, 87.5 (1 to 71 lines)
C                         glongs=0,5,...,360 (0 to 72 cols.)
C
	DIMENSION res(0:72),ires(0:72)
	+,pinp(71,0:72,0:23),XX(0:23) ! -180:5:180 yglon
	CHARACTER*65 infile,outfile
		CHARACTER*2 AYR,AMN,ALT
C 
  101	format(73(1X,F5.1))
   17 format (A2)
   18 format (1X,F6.1,2X,F5.1,2X,24(1X,F7.2))
      WRITE(*,*)' ENTER YR OF INPUT FILE=	'
	read(*,17) AYR
      WRITE(*,*)' ENTER MN OF INPUT FILE=	'
	read(*,17) AMN

	infile='TEC1336_090322.dat' 
	outfile='ptMN00LT.iYR'
      WRITE(*,*)' YR = ',AYR,' MN=',AMN
	infile(11:12)=AMN
	infile(9:10)=AYR

	outfile(3:4)=AMN
	outfile(11:12)=AYR
C
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	OPEN(10,file=infile,action='READ')

C
    1	continue
   13 FORMAT(I2)
	DO 200 ilon=0,72
C	nlat=73
	DO 201 nlat=1,71 
C	nlat=nlat-2  !nlat=71 for glat=87.5; nlat=1 for glat=-87.5
	read(10,18,end=199) xlon,xlat,(XX(k),k=0,23)
	do k=0,23
	pinp(nlat,ilon,k)=XX(k)
	enddo
 201	CONTINUE		 ! cycle ilat

 200	CONTINUE		 ! cycle ilon
 199  CLOSE(unit=10)
C Output of IONEX grids map for each LT:
C Cycle on LT
	do 190 ihr=0,23
	call blet2(ihr,ALT)
	outfile(7:8)=ALT
	OPEN(11,file=outfile)
C
	gilat=-90.0
C 
	DO ilat=1,71
	gilat=gilat+2.5
	gilon=-185.0
	kk=33
		do jlon=0,72
	res(jlon)=pinp(ilat,jlon,ihr)
	ires(jlon)=nint(res(jlon)*100.)
	enddo
	write(*,19) (ires(k),k=0,72)
	write(11,19) (ires(k),k=0,72)


	ENDDO  !gilat cycle
	close(unit=11)
	 
  190	CONTINUE
   19	format(73(1X,I4))
   2	continue
c-      pause ' '
	stop
	end