      program hcmagnet
C.............................................Apr. 2018
C R1(center-of-mass) global Net-index
C
      DIMENSION IM(12),TEC(15,71,0:72,0:23),FF2(15,71,0:72,0:23)
	+,TAU(15,71,0:72,0:23),avtec(0:23),avff2(0:23),avtau(0:23)
	+,CC(15,0:72),SMED(0:72),ires(0:72)
	CHARACTER*128 INFILE1,INFILE2,INFILE3,OUTFILE1,OUTFILE2,OUTFILE3
	+,OUTNET,OUTMED
	CHARACTER*2 ayr,amn,ady,aut,ady2
	 CHARACTER*1 RR,X,Y !=a for AU (R1), =e for EU(R2) or 
	CHARACTER*4	AYMN
	CHARACTER*24 txt
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C Test
	
	infile1='d:\web\dtt\YR\MN\ttmnddutRY.eYR'	 ! TEC for R1 or R2
	infile2='d:\web\graf\xum\yrmnddut.grd'  !foF2 for R1(dlat=2) or R2(dlat=1)
	infile3='d:\web\dtu\YR\MN\tumnddutRY.eYR'  !Tau	 for R1 or R2
	outfile1='d:\web\dem\YR\MN\ttmnddutRY.mYR'  ! -15d median
	outfile2='d:\web\dem\YR\MN\fpmnddutRY.mYR'  ! -15d median
	outfile3='d:\web\dem\YR\MN\tamnddutRY.mYR'  ! -15d median
	outnet='regnetRY.res'
	outmed='regmedRY.res'
   14	format(A1)
   15	format(A4)
        WRITE(*,*)' ENTER rr (e=eu, a =au):'
		READ(*,14) rr
   1        WRITE(*,*)' ENTER yrmn (9999=stop):'
		READ(*,15) AYMN
   2	       WRITE(*,*)' ENTER ADY2 for median <00> STOP:' !-15 day median 
		READ(*,*) ADY2
	if (ADY2.eq.'00') GOTO 33 ! stop
C
	AYR=AYMN(1:2)
	AMN=AYMN(3:4)
C
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	if (iyr.lt.30) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C
       read(AMN,*) rmn
	IMN=int(rmn)   ! current mn
       nmdy=im(imn)
C
	read(ADY2,*) rdy2
	idy2=int(rdy2)
	idy1=idy2-14

        if (rr.eq.'a') then
	Y='1'
	X='a'
	ncol=35	! 0:36
	nlat=41
	else
	Y='2'
	X='e'
	ncol=50 ! 0:50
	nlat=18
	endif
      outnet(8:8)=Y
	OPEN(20,file=outnet,access='APPEND')
      outmed(8:8)=Y
	OPEN(30,file=outmed,access='APPEND')

	outfile1(12:13)=ayr
	outfile1(15:16)=amn
	outfile1(30:31)=ayr
	outfile1(20:21)=amn
	outfile1(22:23)=ady2
	outfile1(27:27)=Y
	outfile2=outfile1
	outfile2(18:19)='fp'
	outfile3=outfile1
	outfile3(18:19)='ta'
C
C temp - for g=fixed month
	infile1(12:13)=AYR
	infile1(30:31)=AYR
	infile1(15:16)=AMN
	infile1(20:21)=AMN
	infile1(27:27)=Y

      	infile2(13:13)=X
	infile2(17:18)=AYR
	infile2(19:20)=AMN

	infile3(12:13)=AYR
	infile3(30:31)=AYR
	infile3(15:16)=AMN
	infile3(20:21)=AMN
	infile3(27:27)=Y
c
        DO 200 idy=idy1,idy2
	nndy=idy-idy1+1
	call blet2(idy,ADY)
	infile1(22:23)=ady
	infile2(21:22)=ady
	infile3(22:23)=ady
C  UT cycle
	DO 260 iut=0,23
	call blet2(iut,AUT)
C
	infile1(24:25)=aut
	infile2(23:24)=aut
	infile3(24:25)=aut
	OPEN(11,FILE=INFILE1,action='READ')				  ! file TEC
C
	OPEN(12,FILE=INFILE2,action='READ')				  ! file CBK foF2
	do i=1,5
	read(12,*) txt	! extra lines
	enddo
C
	OPEN(13,FILE=INFILE3,action='READ')				  ! file Tau
C
  156	format(36(1X,F4.0))
  157	format(51(1X,F4.0))
  158	format(51(1X,F4.1))
  159	format(36(1X,F4.1))
  161	format(51(1X,I4))
  162	format(36(1X,I4))
C
C Cycle of lats:
C
	av1=0.
	cnt=0.
	av2=0.
	av3=0.
       DO lat=1,nlat                 ! LAT cycle
	if (Y.eq.'1') then
    	read (11,159,end=301) (tec(nndy,lat,k,iut),k=0,ncol)      ! file TEC
	else
	read (11,158,end=301) (tec(nndy,lat,k,iut),k=0,ncol)      ! file TEC
	endif
	read (12,*,end=302) (ff2(nndy,lat,k,iut),k=0,ncol)      ! file foF2
	if (Y.eq.'2') then
	read (12,*,end=302) (ff2(nndy,lat,k,iut),k=0,ncol)      ! file foF2
	endif
	if (Y.eq.'1') then
	read (13,156,end=303) (tau(nndy,lat,k,iut),k=0,ncol)      ! file Tau
       else
      read (13,157,end=303) (tau(nndy,lat,k,iut),k=0,ncol)      ! file Tau
	endif
      do k=0,ncol
	av1=av1+tec(nndy,lat,k,iut)
	av2=av2+ff2(nndy,lat,k,iut)
	av3=av3+tau(nndy,lat,k,iut)
	cnt=cnt+1.
	enddo
	 ENDDO  ! end lats
	avtec(iut)=av1/cnt
	avff2(iut)=av2/cnt
	avtau(iut)=av3/cnt
	if (idy.eq.idy2) then
		write(*,304) AYR,AMN,ADY,AUT,avtec(iut),avff2(iut),avtau(iut) ! dy, ut
	write(20,304) AYR,AMN,ADY,AUT,avtec(iut),avff2(iut),avtau(iut) ! dy, ut
	endif
C
  301	close(unit=11)
  302	close(unit=12)
  303 close(unit=13)
  304 format(1X,4A2,3(1X,F7.1))
C
C
  260	continue  ! next UT
C
  200	CONTINUE  ! next day -15, -14, ...,DY2
C
C produce median TEC:
C
C Again cycle on UT      
C
       DO 210 iut=0,23
	call blet2(iut,AUT)
	outfile1(24:25)=aut
	OPEN(21,FILE=OUTFILE1)				  ! TEC
       avmed=0.
	cnt=0.
        DO 201 lat=1,nlat
	  do lon=0,ncol
       	DO kk=1,15
	CC(kk,lon)=tec(kk,lat,lon,iut)
	    ENDDO
	  enddo
		CALL medstd3(CC,ncol,SMED)  ! TEC Med. for 15 prec. days 
	do lon=0,ncol
	avmed=avmed+smed(lon)
	cnt=cnt+1
	ires(lon)=nint(SMED(lon)*10.) ! TEC
	enddo
	if (Y.eq.'1') then
	write(*,306) (ires(k),k=0,ncol)
	write(21,306) (ires(k),k=0,ncol)
	else
	write(*,305) (ires(k),k=0,ncol)
	write(21,305) (ires(k),k=0,ncol)
      endif
  201	continue ! cycle on lats
C
        avtec(iut)=avmed/cnt
	close(unit=21)
  210	continue
C similar cycle for med
C produce median foF2:
       DO 211 iut=0,23
	call blet2(iut,AUT)
	outfile2(24:25)=aut
	OPEN(22,FILE=OUTFILE2)				  ! foF2
       avmed=0.
	cnt=0.
        DO 202 lat=1,nlat
	  do lon=0,ncol
       	DO kk=1,15
	CC(kk,lon)=ff2(kk,lat,lon,iut)
	    ENDDO
	  enddo
		CALL medstd3(CC,ncol,SMED)  ! foF2 Med. for 15 prec. days 
	do lon=0,ncol
	avmed=avmed+smed(lon)
	cnt=cnt+1
	ires(lon)=nint(SMED(lon)*10.) ! foF2
	enddo
		if (Y.eq.'1') then
	write(*,306) (ires(k),k=0,ncol)
	write(22,306) (ires(k),k=0,ncol)
	   else
	write(*,305) (ires(k),k=0,ncol)
	write(22,305) (ires(k),k=0,ncol)
       endif
  202	continue
        avff2(iut)=avmed/cnt
       close(unit=22)
  211	continue
C
C produce median Tau:
      DO 212 iut=0,23
	call blet2(iut,AUT)
	outfile3(24:25)=aut
	OPEN(23,FILE=OUTFILE3)				  ! Tau
       avmed=0.
	cnt=0.
        DO 203 lat=1,nlat
	  do lon=0,ncol
       	DO kk=1,15
	CC(kk,lon)=tau(kk,lat,lon,iut)
	    ENDDO
	  enddo
		CALL medstd3(CC,ncol,SMED)  ! Tau Med. for 15 prec. days 
	do lon=0,ncol
	avmed=avmed+smed(lon)
	cnt=cnt+1
	ires(lon)=nint(SMED(lon)) ! Tau
	enddo
		if (Y.eq.'1') then
	write(*,306) (ires(k),k=0,ncol)
	write(23,306) (ires(k),k=0,ncol)
	else
	write(*,305) (ires(k),k=0,ncol)
	write(23,305) (ires(k),k=0,ncol)
	endif
  203	continue
        avtau(iut)=avmed/cnt
      close(unit=23)
  212	continue
C
  305 FORMAT(51(1X,I4))
  306 FORMAT(36(1X,I4))
C write avmed to netmed outfile:
        DO iut=0,23
	call blet2(iut,AUT)
		write(*,304) AYR,AMN,ADY2,AUT,avtec(iut),avff2(iut),avtau(iut) ! dy2, ut
	write(30,304) AYR,AMN,ADY2,AUT,avtec(iut),avff2(iut),avtau(iut) ! dy2, ut
	enddo
C
        GOTO 2
  33	 close(unit=20)
       close(unit=21)
	pause ' '
	STOP
	END