      program tec2x2jpl
C............................................................Nov. 2017
C 
C Extract TEC maps 2x2 degr at 0:30,1:30,...,23:30 from IONEX files
C TEC from glat x glon ~ 2.5 x 5 deg files
C 2006.01 to 2008.11
C 
C Output:        lati: -90.0,-88.0,...,0,...,88.0,90.0 ==> i=1,2,...91
C                longi:-180.0, -178.0,... 0...178.0 ==> j=0,...,179
C
C
C
      DIMENSION IM(12),tecs(0:179),itec(0:179),TEC_nex(0:179)
	character*55 outfile
	character*2 AYR,AMN,ADY,AUT,BYR,BMN,BDY,BUT
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/

	outfile='d:\web\dtt\YR\MN\ttMNDDUT.eYR'

      write(*,*) ' Enter mon:'
	read(*,*) nmn1

      write(*,*) ' Enter nday1,ndayend:'
	read(*,*) ndy1,ndy2
C
C+      DO 50 nyear=2006,2008
      DO 50 nyear=2007,2007
      z1=nyear/4.0
           if(nyear/4*4.eq.nyear) then
		 im(2)=29
	ndnr=366
	          else
        im(2)=28
	ndnr=365
	endif
	 nyr=nyear-nyear/100*100
	call blet2(nyr,AYR)
	outfile(12:13)=AYR
	outfile(28:29)=AYR
C
	mnend=12
	if (nyear.eq.2008) mnend=11
C
      DO 51 nmn=nmn1,mnend
	call blet2(nmn,AMN)
	outfile(15:16)=AMN
	outfile(20:21)=AMN

	ndmn=im(nmn)
C
Crem      DO 52 ndy=1,ndmn
      DO 52 ndy=ndy1,ndy2   ! Temp !!!!
	call blet2(ndy,ADY)
	outfile(22:23)=ADY
C
C      DO 53 nut=0,23
      DO 53 nut=0,23      ! Temp !!!! 
Ctemp      nut=23
	call blet2(nut,AUT)
	outfile(24:25)=AUT
	Open(20,file=outfile)
C
C++      glat=-92.
       glat=-88.
	do ilat=3,89  ! IONEX [-87.5 87.5]
	glat=glat+2.  !-86, -84,...,86

C++	Cycle on glon is put in subinterp22(glat,syr,smn,sdy,sut,CC)
C/	glon=-182.
C/	do ilon=0,179
C/	glon=glon+2.

	call subinterp22(glat,ayr,amn,ady,aut,TECS)
C/	tec=res
C/      tecs(ilon)=res
C
C next hour UT:
      iyr_nex=nyr
      imn_nex=nmn
	idy_nex=ndy
       iut_nex=nut+1
	if (iut_nex.gt.23) then
       iut_nex=0
	idy_nex=ndy+1
	   if (idy_nex.gt.ndmn) then
         idy_nex=1
	   imn_nex=nmn+1
	      if (imn_nex.gt.12) then
	      imn_nex=1
	      iyr_nex=nyr+1
	      endif
	   endif
	endif
      call blet2(iyr_nex,BYR)
	call blet2(imn_nex,BMN)
	call blet2(idy_nex,BDY)
	call blet2(iut_nex,BUT)

      call subinterp22(glat,byr,bmn,bdy,but,TEC_nex)
C
C Interpolate for half-UT hour (+30 min):
	glon=-182.
	do ilon=0,179
	glon=glon+2.
	itec(ilon)=nint((TECS(ilon)+TEC_nex(ilon))/2.)	! interpolate for half-hour UT+30 min
       enddo !cycle on glon
C++
	if ((ilat.eq.3).or.(ilat.eq.89)) then
	do nn=1,2
C      write(*,44) (itec(k),k=0,179)	! glat=-90, -88; 88; 90 
	write(20,44) (itec(k),k=0,179)
	enddo
	endif
C
C      write(*,44) (itec(k),k=0,179)
	write(20,44) (itec(k),k=0,179)
       enddo ! cycle on glat
C++
	write(*,45) AYR,AMN,ADY,AUT
       close (unit=20)
   53	continue ! cycle on UT
C
   52	continue ! cycle on DY
      goto 55 ! temp++++++++++++++++++
C
   51	continue  ! cycle on MN
C
   50	continue   ! cycle on YR
   44 format(180(1X,I4))
   45 format(4(1X,A2))
   55   pause ' '

C
      STOP
	END