      Program Terminator
C.................................................................................Jan 2023
C glong = -179.5:1.0:179.5
	implicit none
c     .. local scalars ..
      character(256) filenamedat_Term
      integer day,month,year
      integer dayLT,monthLT,yearLT,ist_long,iut !+ist_long
	CHARACTER*4 AYEAR
      CHARACTER*2 AMN,ADY,AUT
      integer i
Cnorm      real UT,alt,st_long,SLT,longi,xlong,lati
              real UT,alt,SLT,longi,xlong,lati
	real:: ax = -90.0
	real:: bx =  90.0
c
      open(1,file='Input\Terminator.inp',status='old',action='READ')
	read(1,*)
Cnorm      read(1,*) day,month,year,UT,alt,st_long 
      read(1,*) day,month,year,UT,alt,ist_long 
	close(1)
c
        call blet4(year,AYEAR)
        call blet2(month,AMN)
	call blet2(day,ADY)
c           Terminator  
      filenamedat_Term = 'Output\TermYEARMNDD.dat'
	filenamedat_Term(12:15)=AYEAR
      filenamedat_Term(16:17)=AMN
      filenamedat_Term(18:19)=ADY
Cnorm	open(2,file=trim(filenamedat_Term))
Cnorm      	open(2,file=filenamedat_Term)
Cnorm	write(2,40)
C
C Cycle on UT
        DO 49 iut=0,23
	UT=float(iut)
	call blet2(iut,AUT)
 	open(2,file=filenamedat_Term,access='APPEND') !new
	write(*,41) AMN,ADY,AUT
	write(2,41) AMN,ADY,AUT
c
       xlong=-180.5
Cnorm	do i=-180,180,st_long
      do 50 i=1,360,ist_long
        xlong=xlong+ist_long
Cnorm	   xlong = i
	   longi = xlong
         if (longi < 0) then
	       longi = longi + 360.0
	   endif
C  
          ax = -90.0
	 bx =  90.0
	   call rconvtime(0,day,month,year,longi,SLT,UT,
     *                            dayLT,monthLT,yearLT)
Cnorm	   call s_terminator(dayLT,monthLT,yearLT,longi,SLT,alt,ax,bx,lati)
	   call sterminator(dayLT,monthLT,yearLT,longi,SLT,alt,ax,bx,lati)
	   write(*,45) xlong,lati
	   write(2,45) xlong,lati
Cnorm	enddo
   50 CONTINUE
      	close(2)			!new
   49 CONTINUE
Cnorm	close(2)
	pause ' '
	STOP
c
  40  format(2x,'longi     lati')
  41  format(2X,2A2,2X,A2)
  45  format(1x,2(f6.1,2x))
      end
c
c         
c  
c ..  :
c .     day -   (integer)
c .   month -  (integer)
c .    year -    (integer)
c
c .   :
c .    nday -    
c
      subroutine nnday(day,month,year,nday)
c     .. scalar arguments ..
      integer day, month, year, nday
c     .. local scalars ..
      integer leap
c 
      nday=31*(month-1)+day
      if(month.le.2) return
      leap=year/4-(year-1)/4
      nday=nday-int(0.4*month+2.3)+leap
c
      return
      end subroutine nnday
c      
c      1 
c  
c ..  :
c .     day -   (integer)
c .   month -  (integer)
c .    year -    (integer)
c
c .   :
c      1  
c .    iday -   (integer)
c .  imonth -  (integer)
c .   iyear -    (integer)
c
      subroutine dayadd(day,month,year,iday,imonth,iyear)
c     .. scalar arguments ..
      integer day, month, year, iday, imonth, iyear
c     .. local scalars ..
      integer daym
c     .. local arrays ..
      integer dayinm(12)
c     ..
      data dayinm/31,28,31,30,31,30,2*31,30,31,30,31/
c
      daym = dayinm(month)
      if (month.eq.2) daym = daym + year/4 - (year-1)/4
      iday = day + 1
      imonth = month
      iyear = year
      if (iday.gt.daym) then
          iday = 1
          imonth = imonth + 1
          if (imonth.gt.12) then
              imonth = 1
              iyear = iyear + 1
          endif
      endif
c
      return
      end subroutine dayadd
c
c      1 
c  
c ..  :
c .     day -   (integer)
c .   month -  (integer)
c .    year -    (integer)
c
c .   :
c      1  
c .    iday -   (integer)
c .  imonth -  (integer)
c .   iyear -    (integer)
c
      subroutine dayres(day,month,year,iday,imonth,iyear)
c     .. scalar arguments ..
      integer day, month, year, iday, imonth, iyear
c     .. local arrays ..
      integer dayinm(12)
c     ..
      data dayinm/31,28,31,30,31,30,2*31,30,31,30,31/
c 
      iday = day - 1
      imonth = month
      iyear = year
      if (iday.eq.0) then
         imonth = month - 1
         if (imonth.eq.0) then
             iday = 31
             imonth = 12
             iyear = year - 1
         else
             iday = dayinm(imonth)
             if (imonth.eq.2) iday = iday+year/4-(year-1)/4
         endif
      endif
c
      return
      end subroutine dayres
c
c      UT ( )  LT ( ) 
c      (vice versa)
c  
c ..  :
c .   jhour = 0 UT  LT, 1 LT  UT (integer)
c .     day -   (integer)
c .   month -  (integer)
c .    year -    (integer)
c .   longi -   (real)
c        LT -   (real) 
c        UT -   (real)
c
c .   :
c        UT -   (real) 
c        LT -   (real)
c .    days -   (integer)
c .  months -  (integer)
c .   years -    (integer)
c
      subroutine rconvtime(jhour,day,month,year,longi,LT,UT,
     * days,months,years)
c     .. scalar arguments ..
      integer jhour, day, month, year, days, months, years
      real longi, LT, UT
c     .. local scalars ..
      real delut
c     .. subroutine references ..
c        dayres, dayadd, nnday
c
      if (longi.lt.180.0) then							   !1
         delut = longi/15.0
         if (jhour.eq.0) then								   !2
            LT = UT + delut
            if (LT.ge.24.0) then							   !3
               LT = LT - 24.0
               call dayadd(day,month,year,days,months,years)
            else											   !3
               days = day
               months = month
               years = year
            endif											   !3
         else												   !2
            UT = LT - delut
            if (UT.lt.0.0) then							   !4
               UT = UT + 24.0
               call dayres(day,month,year,days,months,years)
            else											   !4
               days = day
               months = month
               years = year
            endif											   !4
         endif											   !2
      else													!1
         delut = (360.0-longi)/15.0
         if (jhour.eq.0) then									!5
            LT = UT - delut
            if (LT.lt.0.0) then								!6
               LT = LT + 24.0
               call dayres(day,month,year,days,months,years)
            else												!6
               days = day
               months = month
               years = year
            endif												!6
         else													!5
            UT = LT + delut
            if (UT.ge.24.0) then								!7
               UT = UT - 24.0
               call dayadd(day,month,year,days,months,years)
            else												!7
               days = day
               months = month
               years = year
            endif												!7
         endif												!5
      endif													!1
      return
      end subroutine rconvtime      