      program calwuwlwem
C.......................................................Nov. 2021
C Produce global WUm, WLm, WEm indices from maps in magn. coords
C
      CHARACTER*4 AYEAR
	CHARACTER*2 AMN, ADY
	DIMENSION IM(12)
            DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C++          xlat=-60.0       !South Antarctic TEMPPPPPPPPPPPPPP
          xlat=60.0       !North Arctic TEMPPPPPPPPPPPPPP
C
      DO iyear=1994,2021
	call blet4(iyear,AYEAR)
	imnend=12
	if (iyear.eq.2021) imnend=11
C
	z1=iyear/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyear) THEN
               IM(2)=29
C	dnr=366.
        ELSE
                IM(2)=28
C	  	dnr=365.
	       ENDIF
C
	DO imn=1,imnend
	call blet2(imn,amn)
	idy1=1
       idy2=im(imn)
	if ((iyear.eq.1994).and.(imn.eq.1)) idy1=7
	if ((iyear.eq.2021).and.(imn.eq.11)) idy2=15
	write(*,35) AYEAR,AMN
C
      DO idy=idy1,idy2
	call blet2(idy,ADY)
	call subpianiaWm2(AYEAR,AMN,ADY,xlat)
	enddo
C
       ENDDO
C
         ENDDO
	pause ' '
   35 format(1X,A4,1X,A2)
	STOP
	END