      program cntpelat6
C.........................................................Sep 2021
C 6 lati ranges: -87.5:-60,// -57.5:-30; /./ -27.5: 0;// 0:+27.5; //30:57.5; // 60:87.5
C Prediction efficiency: GTEC ~ UPC, GTEC ~ JPL 
C                      IRI-PLasTEC ~ UPC, IRI-plas ~ JPL
C                      IRI-2016TEC ~ UPC, IRI-2016 ~ JPL
C TECave(UT) => PE(UT) UT=0,1,...,23 h
C ......................................................July 2021
C Cycle on grid maps to 
C produce rms between two maps-data
C Grids = 71 lats 0:72 long
C
C ======= data of TEC maps =======================
C
      DIMENSION DA1(71,0:72),da2(71,0:72),pe1(0:23),pe2(0:23)
	+,pe3(0:23),pe4(0:23),pe5(0:23),pe6(0:23)
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*48 INFILE1,INFILE2,OUTFILE1,outfile2,outfile3,outfile4
	+,outfile5,outfile6
C
c
       do iut=0,23
	pe1(iut)=0.
	pe2(iut)=0.
	pe3(iut)=0.
	pe4(iut)=0.
	pe5(iut)=0.
	pe6(iut)=0.
	 enddo
C ===============================
C
     	outfile1='cntpelat_90.txt'
	outfile2='cntpelat_60.txt'
	outfile3='cntpelat_30.txt'
	outfile4='cntpelatx30.txt'
	outfile5='cntpelatx60.txt'
	outfile6='cntpelatx90.txt'
   1	      OPEN(13,FILE=OUTFILE1,access='APPEND')
      OPEN(14,FILE=OUTFILE2,access='APPEND')
	OPEN(15,FILE=OUTFILE3,access='APPEND')
	OPEN(16,FILE=OUTFILE4,access='APPEND')
	OPEN(17,FILE=OUTFILE5,access='APPEND')
	OPEN(18,FILE=OUTFILE6,access='APPEND')
C
       WRITE(*,*)' ENTER YR <-1> STOP'
	read(*,*) AYR
	if (AYR.eq.'-1') goto 133

	infile1='d:\web\gtc\YR\MN\gtMN15UT.sYR'		!GTEC median
Temp	infile2='fc0MNmap.asc'
C+	infile2='d:\web\graf\dtu\YR\MN\tmMN15UT.uYR'   ! UPC obs median
      infile2='d:\web\dts\YR\MN\tcMN00UT.mYR'   ! JPL obs median
c+	infile1='d:\web\dts\YR\MN\tnMN15UT.mYR'   ! IRI-Plas TEC median	CCIR
C+	infile1='d:\web\dtc\YR\MN\tcMN15UT.iYR'   ! IRI-2016 TEC median	CCIR

		infile1(12:13)=ayr
		infile1(28:29)=ayr
C+		infile2(17:18)=ayr   !UPC
C+		infile2(33:34)=ayr	 !UPC
		infile2(12:13)=ayr  !JPL
		infile2(28:29)=ayr	!JPL
      WRITE(*,*)' ENTER MN'
	read(*,*) AMN
		infile1(15:16)=amn
		infile1(20:21)=amn
C+		infile2(20:21)=amn	  !UPC
C+		infile2(25:26)=amn	  !UPC
		infile2(15:16)=amn	  !JPL
		infile2(20:21)=amn	  !JPL
  30	format(2(1X,A2))
C-      WRITE(*,*)' ENTER idy1,idy2'
C-	read(*,*) idy1,idy2
C
         write(*,30) AYR,AMN
	write(13,30) AYR,AMN
	write(14,30) AYR,AMN
	write(15,30) AYR,AMN
	write(16,30) AYR,AMN
	write(17,30) AYR,AMN
	write(18,30) AYR,AMN
C-      DO 101 idy=idy1,idy2
        idy=15   ! median
	call blet2(idy,ADY)

c-		infile1(30:31)=ady
c-		infile2(30:31)=ady
C
         ntot=0
	totrms=0.
	totav1=0.
	totav2=0.
	DO 770 iut=0,23
	call blet2(iut,AUT)
C
	infile1(24:25)=aut
	infile2(24:25)=aut	 !JPL
C+	infile2(29:30)=aut	  !UPC
 
C
		 open(11,file=infile1,action='READ')
	open(12,file=infile2,action='READ')
  21	continue		
C      write(*,*) infile1,infile2
      if (iut.eq.0) then
	write(13,*) infile1,infile2
      endif
C
C Start input of 1st file: -----------------------
C
c       obsave=0.
        DO lat=1,71
CC
        do kk=0,72
	DA1(lat,kk)=0.
	DA2(lat,kk)=0.
	  enddo
  703	read(11,704,end=705) (DA1(lat,k),k=0,72)
  704	format(73(1X,F4.1))
C
C =======================================================
C Start input of 2nd file: Obs
 1703	read(12,704,end=199) (DA2(lat,k),k=0,72)
c+       do k=0,72
c+	obsave=obsave+da2(lat,k)
c+	 enddo
C
        enddo      ! end reading lat, long
C
       obsave1=0.
	obsave2=0.
	obsave3=0.
	obsave4=0.
	obsave5=0.
	obsave6=0.
	glat=-90.
	n1=0
	n2=0
	n3=0
	n4=0
	n5=0
	n6=0
	do lat=1,71
	glat=glat+2.5
	           do k=0,72		  ! long
	if (glat.le.-60.0) then
      obsave1=obsave1+da2(lat,k)
	n1=n1+1
	endif
	if ((glat.gt.-60.0).and.(glat.le.-30.0)) then
      obsave2=obsave2+da2(lat,k)
	n2=n2+1
	endif
	if ((glat.gt.-30.0).and.(glat.le.0.0)) then
      obsave3=obsave3+da2(lat,k)
	n3=n3+1
	endif
	if ((glat.ge.0.0).and.(glat.lt.30.0)) then
      obsave4=obsave4+da2(lat,k)
	n4=n4+1
	endif
	if ((glat.ge.30.0).and.(glat.lt.60.0)) then
      obsave5=obsave5+da2(lat,k)
	n5=n5+1
	endif
	if ((glat.ge.60.0).and.(glat.lt.90.0)) then
      obsave6=obsave6+da2(lat,k)
	n6=n6+1
	endif
	             enddo      ! long
	enddo
	 tecave1=obsave1/n1
	tecave2=obsave2/n2
	tecave3=obsave3/n3
	tecave4=obsave4/n4
	tecave5=obsave5/n5
	tecave6=obsave6/n6
C-  705 close(unit=11)
c-  199 close(unit=12)
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C Output of results RMS after calculation:
  	rms=0.
	dev=0.
	nn=0
	av1=0.
	av2=0.
	dtop1=0.
	dbot1=0.
	dtop2=0.
	dbot2=0.
	dtop3=0.
	dbot3=0.
	dtop4=0.
	dbot4=0.
	dtop5=0.
	dbot5=0.
	dtop6=0.
	dbot6=0.
C
	glat=-90.
	do 198 mm=1,71
      glat=glat+2.5
C
	IF (glat.le.-60.0) THEN
      do ii=0,72
	av1=av1+da1(mm,ii)
	av2=av2+da2(mm,ii)
	del=da1(mm,ii)-da2(mm,ii)  !
	dtop1=dtop1+del**2
	dbot1=dbot1+(da2(mm,ii)-tecave1)**2
	dev=dev+del
	rms=rms+del**2.
c	nn=nn+1
  	enddo	  ! lon cycle
                      ENDIF
C
	IF ((glat.gt.-60.0).and.(glat.le.-30.0)) THEN
      do ii=0,72
	av1=av1+da1(mm,ii)
	av2=av2+da2(mm,ii)
	del=da1(mm,ii)-da2(mm,ii)  !
	dtop2=dtop2+del**2
	dbot2=dbot2+(da2(mm,ii)-tecave2)**2
	dev=dev+del
	rms=rms+del**2.
c	nn=nn+1
  	enddo	  ! lon cycle
                      ENDIF
C
	IF ((glat.gt.-30.0).and.(glat.le.0.0)) THEN
      do ii=0,72
	av1=av1+da1(mm,ii)
	av2=av2+da2(mm,ii)
	del=da1(mm,ii)-da2(mm,ii)  !
	dtop3=dtop3+del**2
	dbot3=dbot3+(da2(mm,ii)-tecave3)**2
	dev=dev+del
	rms=rms+del**2.
c	nn=nn+1
  	enddo	  ! lon cycle
                      ENDIF
C
	IF ((glat.ge.0.0).and.(glat.lt.30.0)) THEN
      do ii=0,72
	av1=av1+da1(mm,ii)
	av2=av2+da2(mm,ii)
	del=da1(mm,ii)-da2(mm,ii)  !
	dtop4=dtop4+del**2
	dbot4=dbot4+(da2(mm,ii)-tecave4)**2
	dev=dev+del
	rms=rms+del**2.
c	nn=nn+1
  	enddo	  ! lon cycle
                      ENDIF
C
	IF ((glat.ge.30.0).and.(glat.lt.60.0)) THEN
      do ii=0,72
	av1=av1+da1(mm,ii)
	av2=av2+da2(mm,ii)
	del=da1(mm,ii)-da2(mm,ii)  !
	dtop5=dtop5+del**2
	dbot5=dbot5+(da2(mm,ii)-tecave5)**2
	dev=dev+del
	rms=rms+del**2.
c	nn=nn+1
  	enddo	  ! lon cycle
                      ENDIF
C
	if ((glat.ge.60.0).and.(glat.lt.90.0)) then
      do ii=0,72
	av1=av1+da1(mm,ii)
	av2=av2+da2(mm,ii)
	del=da1(mm,ii)-da2(mm,ii)  !
	dtop6=dtop6+del**2
	dbot6=dbot6+(da2(mm,ii)-tecave6)**2
	dev=dev+del
	rms=rms+del**2.
c	nn=nn+1
  	enddo	  ! lon cycle
                      ENDIF
C
  198	CONTINUE       ! lats cycle
	pe1(iut)=1.0-sqrt(dtop1/dbot1)
      pe2(iut)=1.0-sqrt(dtop2/dbot2)
	pe3(iut)=1.0-sqrt(dtop3/dbot3)
	pe4(iut)=1.0-sqrt(dtop4/dbot4)
	pe5(iut)=1.0-sqrt(dtop5/dbot5)
	pe6(iut)=1.0-sqrt(dtop6/dbot6)
	if (nn.gt.0) then
	rmsq=sqrt(rms/nn)
	dev=dev/nn
	endif
	totrms=totrms+rms
	totav1=totav1+av1
	totav2=totav2+av2
C
Temp	WRITE(113,158) iut,rms,rmsq,dev,nn
	WRITE(*,158) AYR,AMN,ADY,AUT,pe1(iut)
	WRITE(13,158) AYR,AMN,ADY,AUT,pe1(iut)
	WRITE(*,158) AYR,AMN,ADY,AUT,pe2(iut)
	WRITE(14,158) AYR,AMN,ADY,AUT,pe2(iut)
	WRITE(*,158) AYR,AMN,ADY,AUT,pe3(iut)
	WRITE(15,158) AYR,AMN,ADY,AUT,pe3(iut)
	WRITE(*,158) AYR,AMN,ADY,AUT,pe4(iut)
	WRITE(16,158) AYR,AMN,ADY,AUT,pe4(iut)
	WRITE(*,158) AYR,AMN,ADY,AUT,pe5(iut)
	WRITE(17,158) AYR,AMN,ADY,AUT,pe5(iut)
	WRITE(*,158) AYR,AMN,ADY,AUT,pe6(iut)
	WRITE(18,158) AYR,AMN,ADY,AUT,pe6(iut)
 158  FORMAT(1X,4(A2),1X,F8.3)
c
	ntot=ntot+1
  705 close(unit=11)
  199 close(unit=12)
  770 CONTINUE      ! end cycle on UT
       ave1=0.
	ave2=0.
	ave3=0.
	ave4=0.
	ave5=0.
	ave6=0.
	DO iut=0,23
	ave1=ave1+pe1(iut)
      ave2=ave2+pe2(iut)
	ave3=ave3+pe3(iut)
	ave4=ave4+pe4(iut)
	ave5=ave5+pe5(iut)
	ave6=ave6+pe6(iut)
	ENDDO
	av1=ave1/24.
	av2=ave2/24.
	av3=ave3/24.
	av4=ave4/24.
	av5=ave5/24.
	av6=ave6/24.
	AUT='24'
	WRITE(*,158) AYR,AMN,ADY,AUT,av1
	WRITE(13,158) AYR,AMN,ADY,AUT,av1
	WRITE(*,158) AYR,AMN,ADY,AUT,av2
	WRITE(14,158) AYR,AMN,ADY,AUT,av2
	WRITE(*,158) AYR,AMN,ADY,AUT,av3
	WRITE(15,158) AYR,AMN,ADY,AUT,av3
	WRITE(*,158) AYR,AMN,ADY,AUT,av4
	WRITE(16,158) AYR,AMN,ADY,AUT,av4
	WRITE(*,158) AYR,AMN,ADY,AUT,av5
	WRITE(17,158) AYR,AMN,ADY,AUT,av5
	WRITE(*,158) AYR,AMN,ADY,AUT,av6
	WRITE(18,158) AYR,AMN,ADY,AUT,av6

c-	stot=sqrt(totrms/(nn*ntot))
c-	sav1=totav1/(nn*ntot)
c-	sav2=totav2/(nn*ntot)
c-	WRITE(*,159) AYR,AMN,ADY,stot,sav1,sav2
c-	WRITE(13,159) AYR,AMN,ADY,stot,sav1,sav2

C  159	format(1X,'RMSmaps=',F10.3,' av1=',F10.3,' av2=',F10.3)
  159	format(1X,3A2,3(1X,F10.3))


  699 continue	  ! 
	goto 101
C
  101	continue   ! dayly cycle
  132	close(unit=13)
      close(unit=14)
	close(unit=15)
	close(unit=16)
	close(unit=17)
	close(unit=18)
	write(*,*) infile1,infile2
	goto 1
 133	pause '  '
      STOP
	END
c--------------------------------------------------------------------

C Corr-coef calculation:
	subroutine corcoef(nn,res1,res2,corf,sf12)
C	nn - number of pair X,Y
	dimension res1(999),res2(999)
	cnt=float(nn)
	af1f2=0.
	af1=0.
	af2=0.
	aff1=0.
	aff2=0.

C
	do i=1,nn
	af1f2=af1f2+res1(i)*res2(i)
	af1=af1+res1(i)
	af2=af2+res2(i)
	aff1=aff1+res1(i)*res1(i)
	aff2=aff2+res2(i)*res2(i)
	enddo
	af1f2=af1f2/cnt
	af1=af1/cnt
	af2=af2/cnt
	aff1=aff1/cnt
	aff2=aff2/cnt

	corf=(af1f2-af1*af2)/(sqrt(aff1-af1*af1)*sqrt(aff2-af2*af2))

C  Dispersion:
	sf1=sqrt(aff1-af1*af1)
	sf2=sqrt(aff2-af2*af2)
	sf12=sf2*sqrt(1.-corf)
	bf21=corf*sf2/sf1
	avf1=af1
	avf2=af2

C Output of results
c	WRITE(*,150) corf,sf12,corx,sx12,avf1,sf1,avf2,sf2,bf21
c	+,avx1,sx1,avx2,sx2,bx21,ii
	RETURN
	end