C					                                  May 2016
C       Convert global daily-hourly mean pTEC(UT) in magn. coords to monthly mean pTEC(mlat,LT)
C Input: geogr. coord. UT /d:/web/dtc/YR/MN/pcMNDYUT.jYR NeQuick-Plas-CCIR => monthly combined  LT /pcMN00LT.jyr 
C or	   geogr. coord. UT /d:/web/dtc/YR/MN/ptMNDYUT.jYR IRI-Plas-TECfit	  => monthly combined  LT /ptMN00LT.jyr
      program convmapltp
C
      DIMENSION im(12),dav(71,0:24),icnt(71,0:24),av(0:23)
	+,iav(0:24),idlt(71,0:72),ptec(0:72)
      character*2 ayr,amn,aut
	character*1 pt
	character*45 infile,outfile
	character*4 AYEAR

	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/

c
c Add input of fm:
       write(*,*) 'ENTER c or p:'
	 read(*,*) pt
C      pt='p'  !TEMP
C
  202 format(73(1X,I4))
C
   31    write(*,*) 'ENTER YEAR:'
	 read(*,*) AYEAR
	AYR=AYEAR(3:4)
       write(*,*) 'ENTER MN:'
	 read(*,*) AMN
		read(ayr,*) yr
		read(amn,*) rmn
	imn=int(rmn)
C
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	ndnr=im(imn)
C
C 
C
       infile='d:\web\dtc\yy\mm\pcmn00ut.ayr'
	infile(18:18)=pt
	infile(12:13)=ayr
	infile(28:29)=ayr
	infile(15:16)=amn
	infile(20:21)=amn
	outfile='d:\web\dts\yy\mm\poyymmlt.txt'
	outfile(18:18)=pt
	outfile(12:13)=ayr
	outfile(20:21)=ayr
	outfile(15:16)=amn
	outfile(22:23)=amn
	OPEN(110,FILE=outfile)
C
C
   18	continue
      do lat=1,71
	do k=0,24
	dav(lat,k)=0.
	icnt(lat,k)=0
	enddo
	enddo
C
C cycle	UT
C
      do 203 iut=0,23
	call blet2(iut,aut)
	infile(24:25)=aut
      OPEN(111,FILE=INFILE)
C
  107 format(73(1X,F4.0))	! 

	do ilat=1,71
	READ (111,107,END=99,ERR=2) (ptec(k),k=0,72) !map lines
	do ii=0,72
	ilt=iut+idlt(ilat,ii)
	if (ilt.gt.23) ilt=ilt-24
	dav(ilat,ilt)=dav(ilat,ilt)+ptec(ii)
	icnt(ilat,ilt)=icnt(ilat,ilt)+1
      enddo				   ! end long
	enddo				   ! end mlat

   99	close(unit=111)
  203 continue   ! end ut cycle

C output results for UT:
      DO lat=1,71
	do k=0,23
	av(k)=dav(lat,k)/icnt(lat,k)
	iav(k)=nint(av(k))
	enddo
	iav(24)=iav(0)
	write(*,108) (iav(k),k=0,24)
	write(110,108) (iav(k),k=0,24)
      ENDDO
  108 format(25(1X,I4))	! 
  109 format(24(1X,I4))	! 
      close(unit=110)
	write(*,*) infile,outfile
	GOTO 31         ! next mn
C
C       GOTO 33
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 34
   33	continue
      pause ' ' 
   34   STOP
       END

