      program magmapionex
C.................................................................Nov 2015
C extract TEC in magnetic coordinat from GIM-TEC
C Magnetic grids maps in IONEX grids for mlats=-87.5,-85,...,85, 87.5 (1 to 71 lines)
C                         mlongs=0,5,...,360 (0 to 72 cols.)
C
	DIMENSION IM(12)
	+,glatm(71,0:72),glonm(71,0:72)
	CHARACTER*65 inglats,inglons
		CHARACTER*2 AYR,AMN,ADY
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	common/BLMAG/glatm,glonm
C Read geogr. coords. for magn. grids
 	inglats='glatgrid1.txt'
	inglons='glongrid1.txt'
  101	format(73(1X,F5.1))
	OPEN(10,file=inglats)
	OPEN(11,file=inglons)
C

	do i=1,71
	read(10,101) (glatm(i,k),k=0,72)
	do k=0,72
	if (glatm(i,k).gt.87.5) glatm(i,k)=87.5
	if (glatm(i,k).lt.-87.5) glatm(i,k)=-87.5
	enddo
      read(11,101) (glonm(i,k),k=0,72)
	enddo
	close(unit=10)
	close(unit=11)
Crem	AYR='14'
      WRITE(*,*)' ENTER YR OF INPUT FILE=	'
	read(*,17) AYR
	WRITE(*,*)' YR = ',AYR
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
C
    1	continue
C>	iyr=iyr+1
	if (iyr.eq.16) GOTO 2
	if (iyr.ge.100) iyr=iyr-100
	call blet2(iyr,AYR)
C?	if (iyr.lt.20) then
C?	iyyyy=2000+iyr
C?	              else
C?	iyyyy=1900+iyr
C?	endif
	z1=iyr/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyr) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C=	imn=1
      WRITE(*,*)' ENTER MN'
	READ(*,13) IMN
 199  continue
   13 FORMAT(I2)

C Cycle on MN	   ++++++++++++++++++++++++++++++++
C=	DO IMN=1,12
 	call blet2(imn,amn)  ! current month

ctemp	idys=1           ! Cycle on day-to-day

	WRITE(*,*)' ENTER IDY1 '
	READ(*,13) IDYS
	IDYS2=IDYS+4

C	idys=1
C	idys2=im(imn)
 201	CONTINUE		 ! cycle on days
   17 format (A2)

      DO idy=idys,idys2	  
C=  200 idy=0
	call blet2(idy,ADY)
C=	ADY='00'
		call subexmag3(AYR,AMN,ADY)
	ENDDO ! end day-to-day cycle
C=		ENDDO ! end monthly cycle
c=	if (imn.lt.12) then
c=	imn=imn+1
c=      goto 199
c=	else
c=	iyr=iyr+1
c=	goto 1
c=	endif 
   2	continue
c-      pause ' '
	stop
	end