      program map24ltcc
C..................................................................May.2016
C grids: mlats -60.0:2,5:60.0; LT 0:1:24;
C Pearson Corr Coef between 2 maps: pjYRMNmlat.tlt (J2 pTEC) & piYR0MNmlat.tlt (IRI-Plas-CCIR pTEC)
C NO  >>>         pjYRMNmlat.tlt (J2 pTEC) & ptYR0MNmlat.tlt (IRI-Plas-TECfit pTEC)
C
C
	dimension XX(49,0:24),YY(49,0:24)
	CHARACTER*28 INFILE1,INFILE2,outfile
	character*2 ayr,amn
C
	infile1='pjyrmnmlat.tlt'
	outfile='ccjimlat.tlt'
	OPEN(10,file=outfile)
C
  20	WRITE(*,*) 'Enter AYR and AMN (AMN=00 Stop) for input: '
	read(*,*) AYR,AMN
	if (amn.eq.'00') goto 33
	infile2='piyrmnmlat.tlt'  ! option 1
   	infile1(3:4)=AYR
	infile1(5:6)=AMN
	infile2(3:4)=AYR
	infile2(5:6)=AMN
C Option 1
	irun=0
   21   irun=irun+1
C
C>>	if (irun.eq.2) GOTO 66  ! avoid reading J2 file at option 2
	OPEN(11,file=infile1,action='READ')
	xav=0.
	do lat=1,49
	read(11,24) (xx(lat,k),k=0,24)
	do k=0,24
	xav=xav+xx(lat,k)
	enddo
	enddo
	close(unit=11)
	xav=xav/1225.
C
   66	CONTINUE
C
	OPEN(12,file=infile2,action='READ')
	yav=0.
	do lat=1,49
	read(12,24) (yy(lat,k),k=0,24)
	do k=0,24
	yav=yav+yy(lat,k)
	enddo
	enddo
	close(unit=12)
	yav=yav/1225.
C
	s1=0.
	s2=0.
	s3=0.
      do lat=1,49
	do lt=0,24
	dx=xx(lat,lt)-xav
      dy=yy(lat,lt)-yav
	s1=s1+dx*dy
	s2=s2+dx*dx
      s3=s3+dy*dy
	enddo
	enddo
	cc=s1/sqrt(s2*s3)
55	format(2(1X,A2),1X,F5.2)
c	write(*,25) (zz(k),k=0,24)
c	write(10,25) (zz(k),k=0,24)
	write(*,55) AYR,AMN,cc
	write(10,55) AYR,AMN,cc
C      ptyrmnmlat.tlt'  ! option 2
c	infile2(2:2)='t'
c	outfile(2:2)='t'
c	if (irun.eq.1) then 
c	GOTO 21
c	               else
c	write(*,*) AYR,AMN
      GOTO 20
c	endif				     
   24	format(25(1X,F5.2))
   25 format(25(1X,F7.2))
	goto 33
    2	write(*,*) 'Error reading data file',infile1,infile2
   33	continue
	close(unit=10)
	pause ' '
   31	stop
	end


