      program map24ltdev
C..................................................................May.2016
C grids: mlats -60.0:2,5:60.0; LT 0:1:24;
C Deviations between 2 maps: pjYRMNmlat.tlt (J2 pTEC) & piYR0MNmlat.tlt (IRI-Plas-CCIR pTEC)
C                        or: pjYRMNmlat.tlt (J2 pTEC) & ptYR0MNmlat.tlt (IRI-Plas-TECfit pTEC)
C
C
	dimension XX(49,0:24),YY(0:24),ZZ(0:24)
	CHARACTER*28 INFILE1,INFILE2,outfile
	character*2 ayr,amn
C
	infile1='pjyrmnmlat.tlt'
	outfile='diyrmnmlat.tlt'
  20	WRITE(*,*) 'Enter AYR and AMN (AMN=00 Stop) for input: '
	read(*,*) AYR,AMN
	if (amn.eq.'00') goto 33
	infile2='piyrmnmlat.tlt'  ! option 1
   	infile1(3:4)=AYR
	infile1(5:6)=AMN
	infile2(3:4)=AYR
	outfile(2:2)='i'
	outfile(3:4)=AYR
	infile2(5:6)=AMN
	outfile(5:6)=AMN
C Options 1, 2
	irun=0
   21   irun=irun+1
C
	OPEN(10,file=outfile)
	if (irun.eq.2) GOTO 66  ! avoid reading J2 file at option 2
	OPEN(11,file=infile1,action='READ')
	do lat=1,49
	read(11,24) (xx(lat,k),k=0,24)
	enddo
	close(unit=11)
C
   66	CONTINUE
C
	OPEN(12,file=infile2,action='READ')
	do lat=1,49
	read(12,24) (yy(k),k=0,24)
	do k=0,24
	ZZ(k)=(xx(lat,k)-yy(k))/xx(lat,k)*100.   !dev %
	enddo
	write(*,25) (zz(k),k=0,24)
	write(10,25) (zz(k),k=0,24)
	enddo
	close(unit=12)
	close(unit=10)
C      ptyrmnmlat.tlt'  ! option 2
	infile2(2:2)='t'
	outfile(2:2)='t'
	if (irun.eq.1) then 
	GOTO 21
	               else
	write(*,*) AYR,AMN
      GOTO 20
	endif				     
   24	format(25(1X,F5.2))
   25 format(25(1X,F7.2))
	goto 33
    2	write(*,*) 'Error reading data file',infile1,infile2
   33	continue
	pause ' '
   31	stop
	end


