      program maprmse
C..................................................................Feb.2016
C IONEX grids -87.5:2,5:87.5; -180:5:180;
C Deviations between 2 maps: tpMN00LT.jYR (J2 pTEC) & tpMN00LT.iYR (IRI-Plas pTEC)
C Histogram for RMSE [0 0.5],[0.5 1.0] [1.0 1.5],[1.5 2.0] [2.0 2.5] [2.5 3.0]
C
C
	dimension XX(71,0:72),YY(71,0:72),ZZ(0:72)
	+,icnts(10),rmse(10),pers(10)
	CHARACTER*28 INFILE1,INFILE2,outfile2
	character*2 ayr,amn,alt
C
	infile1='ptmn00LT.jyr'
	infile2='ptmn00LT.iyr'
	outfile2='maprmse.txt'
	OPEN(10,file=outfile2,access='APPEND')
C
	WRITE(*,*) 'Enter AYR and AMN for input: '
	read(*,*) AYR,AMN
C
	read(ayr,*) yr
	iyr=int(yr)
	read(amn,*) rmn
	imn=int(rmn)

	write(*,23) ayr,amn
   24	format(1X,A12,1X,A12)
   25 format(A1)	 
	infile1(3:4)=amn
	infile1(11:12)=ayr
	infile2(3:4)=amn
	infile2(11:12)=ayr
  100	format(73(1X,F4.2))
  101	format(73(1X,I4))
  102	format(73(I5))
	write(*,24) infile1,infile2
	write(10,24) infile1,infile2
C
C day-to-day cycle
C LT-cycle Input for 00,04,...23 LT; 
	ii=0
	do 70 ilt=0,23
	call blet2(ilt,ALT)
	infile1(7:8)=alt
	 infile2(7:8)=alt
c	outfile1=infile1
c	outfile1(1:1)='d'
		OPEN(11,FILE=INFILE1)
c		OPEN(12,FILE=OUTFILE1)
		OPEN(13,FILE=INFILE2)
	do kk=1,71
	read(11,100,END=9,ERR=2) (xx(kk,i),i=0,72)
	read(13,100,END=19,ERR=2) (yy(kk,i),i=0,72)
	enddo
   9	close(unit=11)
   19	close(unit=13)
C  Cycle on thresholds
	tres=-0.5
       DO 69 ii=1,10
	tres=tres+0.5
	treup=tres+0.5
	if (ii.eq.10) treup=15.0
	icnts(ii)=0.
	rmse(ii)=0.
	icntot=0
	icnt=0
	sum=0.
C cycle on lats
	do kk=1,71				!<<<<<<<<<<<<<<<<<<
C cycle on longs
	do 20 k=0,72               !..................
	if (xx(kk,k).le.0.0) then
	goto 20 !missed value
	else
	icntot=icntot+1
	endif
	if (xx(kk,k).gt.990.) goto 20
	xdat=xx(kk,k)
	ydat=yy(kk,k)
	zz(k)=(xdat-ydat)/xdat
	azz=abs(zz(k))
	if(azz.gt.2.) then
	azz=2.0
	  if (xdat.lt.ydat) then
	  ydat=3.*xdat
	  zz(k)=-2.
	  else
	  ydat=-xdat
	  zz(k)=2.
        endif	
	endif
	dev=(xdat-ydat)**2
	sum=sum+dev
	icnt=icnt+1
	if (icnt.gt.0.) rms=sqrt(sum/icnt)
C chech thresholds interval:

	if ((rms.ge.tres).and.(rms.lt.treup)) then
	rmse(ii)=rms
	icnts(ii)=icnt
	xx(kk,k)=999.
	                           else
	sum=sum-dev
	icnt=icnt-1
	endif
   20	continue				!..................
	enddo			! end lats <<<<<<<<<<<<<<<<<< 
C
	pers(ii)=float(icnts(ii))/icntot*100.
   69 continue        ! end cycle on thresholds

c  125	write(*,23) AYR,AMN,ALT,(icnts(k),rmse(k),k=1,10),icntot
c      write(10,23) AYR,AMN,ALT,(icnts(k),rmse(k),k=1,10),icntot
  125	write(*,21) AYR,AMN,ALT,(pers(k),rmse(k),k=1,10),icntot
      write(10,21) AYR,AMN,ALT,(pers(k),rmse(k),k=1,10),icntot
   70	continue !		 ! end cycle on LT
	   close(unit=10)
   23	format(3(1X,A2),10(1X,I4,1X,F7.4),1X,I4)
   21	format(3(1X,A2),10(1X,F6.2,1X,F7.4),1X,I4)
	goto 33
    2	write(*,*) 'Error reading data file',infile1,infile2
   33	continue
	pause ' '
   31	stop
	end


