C.......................................................Jul. 2020
C
C.......................................................Aug. 2014
C
C Monthly median map for UT => output
C					                                  Aug. 2013
C
C       Count global median afc(UT) and ahc*UT) for maps TEC, fcF2 and hcF2 
C input maps for given UT
C 
       program medmap3
		dimension IM(12)
 	+,IMEDT(71,0:72,0:23) ! results of median maps
	CHARACTER*4 AYEAR
	CHARACTER*2 AYR,AMN
	CHARACTER*1 ft
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
c-	integer*2 idy1,idy2
c-      COMMON /BMED/IMEDF,IMEDH,IMEDT
	DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
    1  WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
      READ(*,'(A)') AYEAR
		ayr=ayear(3:4)
  999    WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
      READ(*,'(A)') AMN
C
C
	read(ayr,*) yr
	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	ndnr=366
	                          ELSE
	IM(2)=28
	ndnr=365
	ENDIF
	read(amn,*) xmn
	imn=int(xmn)
C
C		WRITE(*,*) 'Enter ndy1, ndy2 for input: '
C 	read(*,987) iDY1,iDY2
  987	format(I2)
C	call blet2(idy1,DY1)
C	call blet2(idy2,DY2)
C

      ft='t'  ! TEC-map
C
C-	read(AYR,*) ryr
C-	IYR=int(ryr)   ! current yr
C-	read(AMN,*) rmn
C-	IMN=int(rmn)   ! current MN
C
200   continue	  

C
	idy1=1
	idy2=im(imn)
	nnn=1

      call smedmap3(nnn,AYEAR,AMN,IMEDT)  !TEC
C
	write(*,*) AYEAR,AMN
       imn=imn+1
	 call blet2(imn,AMN)
	if (imn.lt.13) GOTO 200
      pause ' '
	 STOP
	 END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C	  
      subroutine smedmap3(nnn,AYEAR,AMN,IMED)
C
C      output	fcYYMMUT.mut; hcYYMMUT.mut; tcYYMMUT.mut;
C
      DIMENSION da(31,71,0:72),av(0:72),iav(0:72)
	+,CC(31,0:72)  ! calculate med-map line-by-line for 71 latitudes
	+,IMED(71,0:72,0:23),im(12) ! results of median maps 
      character*2 ayr,amn,ady,aut
	character*1 fht
	character*45 infile,outfile
	character*4 AYEAR
C	integer iyr,mn,idy,iut,imn,idy1,idy2
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
			COMMON /BL1/CC,AV

c
c Add cycle on fm, hm, tm:
c
	if (nnn.eq.1) fht='t'
	if (nnn.eq.2) fht='f'
	if (nnn.eq.3) fht='h'
c
C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c//       write(*,*) 'ENTER YEAR:'
c//	 read(*,*) AYEAR
	AYR=AYEAR(3:4)
c//       write(*,*) 'ENTER MN:'
c//	 read(*,*) AMN
		read(ayr,*) yr
		read(amn,*) rmn
	imn=int(rmn)
C
 	iyr=int(yr)
	if(int(yr/4.)*4.eq.iyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
	ndnr=im(imn)
	idy1=1
	idy2=im(imn)
C
c-		read(ady,*) rdy
c-	jdy=int(rdy)
	lda1=ndoy(iyr,mn,idy1)
	lda2=ndoy(iyr,mn,idy2)
C 
C
       infile='d:\web\dfs\yy\mm\fcmmddut.jyr'	 !Tamara
CREM       infile='d:\web\dfs\yy\mm\fcmmddut.iyr'	 !Tamara
	infile(9:9)=fht								 !Tamara
	infile(18:18)=fht								 !Tamara
	infile(12:13)=ayr								 !Tamara
	infile(15:16)=amn								 !Tamara
	infile(20:21)=amn								 !Tamara
	infile(28:29)=ayr								 !Tamara
C
C UT cycle
	DO 203 iut=0,23
	call blet2(iut,AUT)
	infile(24:25)=AUT								 !Tamara

C Day-to-day cycle
	DO 201 idy=idy1,idy2
C
	call blet2(idy,ady)
	infile(22:23)=ady								 !Tamara
	kk=idy
C
   18	continue
C
C++  Rename file extension tc* or ta* / tb* for prediction files
  700 format(A128)
      OPEN(11,FILE=INFILE)
C
C
C
	do lat=1,71
  107 format(73(1X,F4.0))	! 
	READ (11,107,END=99,ERR=2) (da(kk,lat,k),k=0,72) !map lines
	enddo				   ! end lati
   99	close(unit=11)
 
  201  CONTINUE				  ! end day-to-day cycle

	do 301 lat=1,71
	do k=0,72
	av(k)=0.
	enddo
C combile all days for selected lati:
	do idy=1,idy2
      	do lon=0,72
	    cc(idy,lon)=da(idy,lat,lon)
	    enddo
	enddo
	call smedian3(idy2)
	  	do lon=0,72
	iav(lon)=nint(av(lon))
	IMED(lat,lon,iut)=iav(lon) ! results of median map
	    enddo
c	   write(*,109) (iav(k),k=0,72)

  301	continue                 ! end lat cycle of median map
	outfile='d:\web\dts\YY\MM\tcMM00UT.mYY'   ! median for mn
 	outfile(12:13)=ayr									!Tamara
	outfile(15:16)=amn									!Tamara
	outfile(28:29)=ayr									!Tamara
	outfile(20:21)=amn									!Tamara
C
c?	DO 300 iut=0,23
c?	call blet2(iut,AUT)
	outfile(24:25)=aut
			OPEN(13,FILE=OUTFILE)
 	do ilat=1,71
crem   	WRITE(*,498) (IMED(ilat,k,iut),K=0,72)
	WRITE(13,498) (IMED(ilat,k,iut),K=0,72)
	enddo
		CLOSE(unit=13)

  300	continue
 498  FORMAT(73(1X,I4))

  203 continue   ! end ut cycle
 
  108 format(3A2,24(1X,I4))	! 
  109 format(73(1X,I4))	! 
      
C
       GOTO 1234
    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY ',infile
 	pause ' '
	goto 34
 1234	continue  !
c//      write(*,*) infile,outfile
c//      pause ' ' 
   34 RETURN
       END

C=========================================================================
c VERIFICATION OF MEDIAN ================
      subroutine smedian3(ndnr)
C Input file: CC(ndnr,0:72) for ndnr days, longitudes -180:5:180
C Number days for median : ndnr=7
C Output array: SME(0:72) for longitudes -180:5:180
	DIMENSION CC(31,0:72),SME(0:72),X1(31),X2(31)
C	integer*2 ndnr
		COMMON /BL1/CC,SME
C "MEDIAN:"
       DO 1030 M=0,72
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
      IF (CD1.LT.XD1) THEN 
	XMD=X2(ND2)
	else
	XMD=(X2(ND1)+X2(ND2))/2.
	ENDIF
C
 1020 SME(M)=XMD
 1030 CONTINUE
c
 1050 RETURN
      END
C=============================================================================