      subroutine subexmag3(ayr,amn,ady)
C................................................Nov 2015
C Produce TEC-map in magnetic coordinated from GIM-TEC
C
C Extract JPL TEC map for maglat=-87.5,-85,...,85,87.5  (71 lines)
C                         maglon=0, 5, 10, ..., 355, 360 (0:72 columns)
C Input: <glatgrid1.txt> <glongrid1.txt> =geogr.coords. for mlat,mlon grids
C 
C
C
C ...............................................Jan. 2013
C extract-interpolate from JPL-TEC or UPC-TEC map 
C
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*1 fm
	CHARACTER*65 outfile,infile
C	+,inglats,inglons
	INTEGER*2 jyr,jmn,jdy,jut
C=	+,jdy1,jdy2
	DIMENSION im(12),itec(0:72)
	+,glats(71,0:72),glons(71,0:72)
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
	common/BLMAG/glats,glons
C
  103	nn=1
  	fm='t'
C Read geogr. coords. for magn. grids
c	inglats='glatgrid1.txt'
c	inglons='glongrid1.txt'
  102	format(73(1X,I4))
c  101	format(73(1X,F5.1))
c	OPEN(10,file=inglats)
c	OPEN(11,file=inglons)
C

c	do i=1,71
c	read(10,101) (glats(i,k),k=0,72)
c	do k=0,72
c	if (glats(i,k).gt.87.5) glats(i,k)=87.5
c	if (glats(i,k).lt.-87.5) glats(i,k)=-87.5
c	enddo
c      read(11,101) (glons(i,k),k=0,72)
c	enddo
c	close(unit=10)
c	close(unit=11)
C
crem	write(*,*) 'enter AYR='
crem	read(*,*) AYR
crem	write(*,*) 'enter AMN='
crem	read(*,*) amn
crem	write(*,*) 'enter idy1,idy2='
crem	read(*,*) jdy1,jdy2
C
 	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
	jmn=int(rmn)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF

c	jdy1=01
c	jdy2=im(jmn)
	read(ady,*) jdy
C	jdy2=jdy1
C
	infile='d:\web\dts\YR\MN\tcMNDDUT.jYR'
	infile(12:13)=AYR
	infile(28:29)=AYR
	infile(15:16)=AMN
	infile(20:21)=AMN

C	outfile='d:\web\dtm\YR\MN\tmMNDYUT.jYR'
C 
C Start cycle on parameter
c-   31	nn=nn+1
c-	if (nn.gt.3) goto 23
C
C Day-to-day cycle
C>	do 120 jdy=jdy1,jdy2
C=	jdy=0
C=	call blet2(jdy,ADY)
	infile(22:23)=ADY
C       
C Cycle on UT
	do 115 jut=0,23
	call blet2(jut,AUT)
	infile(24:25)=AUT

C	outfile='d:\web\dtm\YR\MN\toMNDYUT.jYR'		!TECobs in magn.coord. IONEX grids
		outfile=infile
	outfile(10:10)='m'		!  
	outfile(19:19)='o'		!  
	OPEN(13,file=outfile)
C
C All Mlats for Local noon
  110	DO 100 ilat=1,71
      	DO ilon=0,72 
	glat=glats(ilat,ilon)
	glon=glons(ilat,ilon)
C
C
	call subinterp3(fm,glat,glon,ayr,amn,ady,aut,res)
	itec(ilon)=nint(res)
	   ENDDO
C	write(*,102) (itec(k),k=0,72)
	write(13,102) (itec(k),k=0,72)

C
  100	continue ! End cycle on ilat
	close(unit=13)
Crem	write(*,*) ' UT=',AUT

  115	CONTINUE        ! End cycle on UT
	write(*,*) ' DAY =',ADY
	
  120	CONTINUE        ! End day-to-day cycle
	write(*,121) ayr,amn
  121	format(1X,A2,1X,A2)
c   	pause ' '
   23	RETURN
crem	stop
	end