      program tcsealand
C................................................June 2014
C Extract JPL TEC map 
C                     
C geogr.coords. 
C 
C Output: TECave(sea) and TECave(land) monthly mean
C
C ...............................................Jan. 2013
C extract from JPL-TEC map 
C
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*65 outfile0,outfile1,infile	! 0 ~ sea, 1 ~ land
	INTEGER*2 jyr,jmn,jdy1,jdy2,jdy,jut
	logical lout
	DIMENSION im(12),tec(0:72),res0(12),res1(12)
	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
  103	nn=1

	outfile0='tcseamn0.txt'
	outfile1='tclanmn1.txt'
	OPEN(10,file=outfile0,access='APPEND')
	OPEN(11,file=outfile1,access='APPEND')
	do i=1,12
	res0(i)=0.
	res1(i)=0.
	enddo

C Read geogr. coords.
  102	format(73(1X,F4.1))
  101	format(1X,A2,12(1X,F6.1))
C
  111	write(*,*) 'enter AYR='
	read(*,*) AYR

c-	write(*,*) 'enter AMN='
c-	read(*,*) amn
	infile='d:\web\dts\YR\MN\tcMNDYUT.jYR'
	infile(12:13)=AYR
	infile(28:29)=AYR

C Cycle on mn:
	DO jmn=1,12
	call blet2(jmn,AMN)
c-	write(*,*) 'enter idy1,idy2='
c-	read(*,*) jdy1,jdy2
C
 	read(ayr,*) ryr
	jyr=int(ryr)
	read(amn,*) rmn
c-	jmn=int(rmn)
	if(int(ryr/4.)*4.eq.jyr) THEN 
 	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF

	jdy1=01
	jdy2=im(jmn)
C
	infile(15:16)=AMN
	infile(20:21)=AMN
	tecmn0=0.
	tecmn1=0.
C 
C
C Day-to-day cycle
	do 120 jdy=jdy1,jdy2
	call blet2(jdy,ADY)
	infile(22:23)=ADY
C       
C Cycle on UT
	do 115 jut=0,23
	call blet2(jut,AUT)
	infile(24:25)=AUT
		OPEN(12,file=infile,action='READ')
C
C All lats 
	glat=-90.0
c	cnt0=0.
c	cnt1=0.
  110	DO 100 ilat=1,71
	glat=glat+2.5
	read(12,102,end=51,err=23) (tec(k),k=0,72) 
C
	glon=-185.
      	DO ilon=0,72 
	glon=glon+5.0
	if (glon.lt.0.) glon=glon+360.
C
	call sealand(glat,glon,lout)
	if (lout) then
	tecmn0=tecmn0+tec(ilon) ! sea
c	cnt0=cnt0+1.
	          else
	tecmn1=tecmn1+tec(ilon) ! land
c	cnt1=cnt1+1.
	endif
	   ENDDO
C
  100	continue ! End cycle on ilat
   51 close(unit=12)
  115	CONTINUE        ! End cycle on UT
c	write(*,*) ' DAY =',ADY
  120	CONTINUE        ! End day-to-day cycle
c	cnt0=cnt1*24.*jdy2
c	cnt1=cnt1*24.*jdy2
	cnt0=3226.*24.*float(jdy2)
	cnt1=1957.*24.*float(jdy2)
	res0(jmn)=tecmn0/cnt0
	res1(jmn)=tecmn1/cnt1
	  ENDDO                ! end month-to-month cycle
	write(*,101)  AYR,(res0(k),k=1,12)
	write(10,101) AYR,(res0(k),k=1,12)
	write(*,101)  AYR,(res1(k),k=1,12)
	write(11,101) AYR,(res1(k),k=1,12)
	if (AYR.ne.'13') goto 111
   23	write(*,*) AYR,AMN,ADY,AUT
	close(unit=10)
	close(unit=11)
   	pause ' '
	stop
	end