C........................................................Feb. 2015
C
C Extract TEC 2 x 2 for Reg2 [36:70 N, -10:90 E] for netvolume
C                       Reg1 [-80:0 N, 110-180 E]
C TEC maps 2 x 2 deg. hour maps 00, 01,...,23 h UT
C           input file web/dtt/YY/MM/ttMMDDUT30.eYY & UT30_pre
C  jprg  => output file web/dtt/YY/MM/ttMMDDUT00.eYY
C         lati: -90.0,-88.0,...,0,...,88.0,90.0 ==> i=1,2,...91
C         longi:-180.0, -178.0,... 0...178.0 ==> j=0,...,179
C output <jhrgDDD0.iYR>
C 
      PROGRAM tecreg2x2
C----------------------------------------------------------------
C Select NEW+++:output 91 geographic latitudes: res1=90.0, 88.0,86,,.0..-90.0N 
C at: NEW+++: 0,1,...,91 geographic longitudes [-180,-178,...,178] = IONEX1 x 2 step
C Produce results for 0, 1,..., 23hr UT.iyr ~ 0.5, 1.5, ..., 23.5 hr UT 
C send results to d:/web/graf/dtr/YY/MM/trMMDDUT.jYY
C
C program for EXTRACTING FROM "JPRGdoy0.iYR" ionex1_TEC data 
C +++++++++
C
C*********TEST
      dimension iglats(91),iglons(0:180),itec(0:180)
C**********TEST
      CHARACTER*128 INFILE,OUTFILE1,OUTFILE2,outfile
	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 AYEAR
	CHARACTER*2 AYR,AMN,ADY,AUT
	dimension im(12)

	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C++
        OUTFILE='tecreg2x2.res'
	OPEN(13,file=outfile,access='APPEND')
C
	iglat=-92
	DO i=1,91
	iglat=iglat+2
	if (iglat.eq.-80) nlat1a=i
	if (iglat.eq.0) nlat1b=i
	if (iglat.eq.36) nlat2a=i
	if (iglat.eq.70) nlat2b=i
	iglats(i)=iglat
	ENDDO
C
	iglon=-182
	do i=0,180
	iglon=iglon+2
	if (iglon.eq.110) nlon1a=i
	if (iglon.eq.180) nlon1b=i
	if (iglon.eq.-10) nlon2a=i
	if (iglon.eq.90) nlon2b=i
	iglons(i)=iglon
	enddo
C++
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT

C cycle on year
C	AYEAR=DD(1:4)                  !               
	write(*,*) ' Enter YEAR: '
	read(*,118) AYEAR
	write(*,*) AYEAR
		AYR=ayear(3:4)
	read(ayr,*) ryr
	iyr=int(ryr)
	read(ayear,*) xyear
	IYYYY=int(xyear)
C following comands for month
		WRITE(*,*) 'Enter AMN for input: '  !
	 	read(*,*) AMN					   !
C	AMN=DD(5:6)               !
   1	write(*,*) amn

	read(amn,*) xmn
	imn=int(xmn)
C

		if(int(ryr/4.)*4.eq.iyr) THEN 
	IM(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
  987	format(I2)

C  data-DAY
C		WRITE(*,*) 'Enter dy for input: '  !
C	 	read(*,*) idy					   !
C
		infile='d:\web\dtt\YR\MN\ttMMDDUT00.eYR'	!
	infile(12:13)=ayr					 !
	infile(30:31)=ayr					 !
	infile(15:16)=amn					 !
		infile(20:21)=amn					 !
C
	outfile1='d:\web\dtt\yy\mn\ttMNDYUTr1.eYR' ! au
	outfile2='d:\web\dtt\yy\mn\ttMNDYUTr2.eYR' ! eu
	outfile1(12:13)=AYR						 !
	outfile1(15:16)=AMN					 !
	outfile1(30:31)=AYR					 !
	outfile1(20:21)=AMN					 !
	     outfile2(12:13)=AYR						 !
		 outfile2(15:16)=AMN					 !
		 outfile2(30:31)=AYR					 !
	     outfile2(20:21)=AMN					 !
C
      mndy=im(imn)
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C daily cycle
C
  	DO 40 idy=1,mndy
      call blet2(idy,ady)
C	
	infile(22:23)=ady					 !
	outfile1(22:23)=ADY						 !
	outfile2(22:23)=ADY						 !
C
	write(*,199) ayr,amn,ady,aut !TEMP
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C  UT cycle
C
	IRUN=0 ! 
      DO 41 iut=0,23 ! 
      call blet2(iut,AUT)
	infile(24:25)=aut					 !
	outfile1(24:25)=AUT
	outfile2(24:25)=AUT
C
C
C

  118	format(A4)
cc	pause  ' '
C
C =========================================
C output tec for -180, -178,...00,02,...,178 deg.E
	do i=1,91
	itec(i)=0	! output TEC lat x long (2 x 2) array 
	enddo
c
  198 format(1X,A39,1X,A39)
	OPEN(10,FILE=INFILE,ACTION='READ') ! TEC input for UT+30 min
	OPEN(11,FILE=OUTFILE1) ! TEC input for Reg1 = au
	OPEN(12,FILE=OUTFILE2) !TEC results   ! Reg2 = eu
CC
CREM	write(*,199) ayr_pre,amn_pre,ady_pre,aut_pre,ayr,amn,ady,aut !TEMP
  199	format(4(1X,A2))
     	tecr1=0. ! au [-80 -42]
	tecr2=0. ! au [-80 -42]
	tecr3=0. ! eu
	cnt1=0.
	cnt2=0.
	cnt3=0.
C++
C INPUT-OUTPUT OF RESULTS
	glat=-92.
	DO 50 nnlat=1,91		!Output for glats=-90.0,88,..., 90.0
	glat=glat+2.0
	read(10,182,end=32,err=2) (itec(k),k=0,179)
	itec(180)=itec(0)
C
       if (nnlat.lt.nlat1a) goto 50
	if ((nnlat.gt.nlat1b).and.(nnlat.lt.nlat2a)) goto 50
       if (nnlat.gt.nlat2b) goto 32 ! end for both Reg1 and Reg2
	 if ((nnlat.ge.nlat1a).and.(nnlat.le.nlat1b)) then
	do i=nlon1a,nlon1b
	if (i.lt.nlon1a+19) then
	tecr1=tecr1+itec(i)/10.
	cnt1=cnt1+1.
	                    else
	tecr2=tecr2+itec(i)/10.
	cnt2=cnt2+1.
	endif
	enddo
C	write(*,183) (itec(k),k=nlon1a,nlon1b)  !Test
	write(11,183) (itec(k),k=nlon1a,nlon1b)		!Reg1 au
	                            else
	do i=nlon2a,nlon2b
	tecr3=tecr3+itec(i)/10.
	cnt3=cnt3+1.
	enddo
C	write(*,184) (itec(k),k=nlon2a,nlon2b)  !Test Reg 2 eu
	write(12,184) (itec(k),k=nlon2a,nlon2b)
      endif
   50	CONTINUE                   ! lats cycle
C
  32		close(unit=10)
  33		close(unit=11)
  		close(unit=12)
	tecnet1=tecr1/cnt1
	tecnet2=tecr2/cnt2
	tecnet3=tecr3/cnt3
	write(*,185) AYR,AMN,ADY,AUT,tecnet1,tecnet2,tecnet3
	write(13,185) AYR,AMN,ADY,AUT,tecnet1,tecnet2,tecnet3
   41 CONTINUE    !   End calculation for given UT

   40 CONTINUE    !     Daily cycle


 182	format(180(1X,I4))							
 183	format(36(1X,I4))  ! longs = [110:2:180]E au
 184	format(51(1X,I4))  ! longs = [-10:2:90]E  eu
 185	format(1X,4A2,3(1X,F6.1))
C
C Continue to the next UT hr :
C++++++++++++++++++++++++++++
C
C 
		goto 36	   ! next month calculations
C
c	write (*,888) alat,alon,aday
c  888	format(1X,' alat=',A3,' alon=',A3,' day=',A3)

    2 CONTINUE
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 35

   34 CONTINUE
C temp
   36	imn=imn+1
	if (imn.le.12) then
	call blet2(imn,AMN)
	goto 1
	endif
   35	close(unit=13)
      write(*,*) infile,outfile1,outfile2
      pause ' ' 
      STOP
       END

C***********************************************************
C
      subroutine submmdd(lda,iyr,imn,idy)
C To define imn & idy using iyr & lda=day-of-year
C
	       DIMENSION IM(0:12)
	integer*2 iyr,imn,idy,nyr,ii
	DATA IM/31,31,28,31,30,31,30,31,31,30,31,30,31/
	nyr=iyr
	imn=0
	idy=0
	z1=nyr/4.0
      jz1=int(z1)*4
      IF(jz1.EQ.nyr) THEN
               IM(2)=29
	ndyr=366
        ELSE
                IM(2)=28
	ndyr=365
	       ENDIF
C Day-of-year = LDA
c//	write(*,*) lda
c//	pause ' '
C Define imn & idy
C NEW++++++++++++++++++++
	mosum=0
         do 1234 ii=1,12
	ndsum=mosum
	mosum=mosum+im(ii)
	imn=ii
	if (lda.le.mosum) then
	idy=lda-ndsum
	 goto 33
	exit
	endif
1234    continue
 33     continue
	RETURN
	END 
C ===============================================================
C ===========================================================
	subroutine SUBTREAD1(nn,yy)
C                                                             ! June 2015   
C
C   EXTRACT TEC FROM IONEX1 format to array yy(glat,glon) relevant to IONEX format
c
C
C
c
      DIMENSION txx(0:179),yy(91,0:179),xxx(16)
	character*60 txt

  90	format(3X,F5.1,A60)
180	format(16(1X,F4.0))
179	format(4(1X,F4.0))

c-	do j=1,3
	do k=0,179
	txx(k)=0.
	enddo
c-	enddo
	alat=92.	! resuts alat
	glat1=92.
	trem=20.

C===

	DO 20 ii=1,91 ! cycly on output lats
	alat=alat-2.0
   10	read(nn,90,err=2,end=9) glat,txt
	glat2=glat
C
	do j=1,11
	j1=(j-1)*16
    1	READ (nn,180,END=9,ERR=2) (xxx(i),i=1,16)
	do k=1,16
	if ((xxx(k).le.0.).or.(xxx(k).gt.9990.)) then
	if (txx(j1+k-1).gt.0.) then
	xxx(k)=txx(j1+k-1)	! replace wrong TEC
	                          else
	xxx(k)=trem ! replace wrong TEC
	endif
	                                       endif
	txx(j1+k-1)=xxx(k)
	trem=xxx(k)
	enddo
	enddo
	 READ (nn,179,END=9,ERR=2) (xxx(i),i=1,4)
		do k=1,4
	if ((xxx(k).le.0.).or.(xxx(k).gt.9990.)) then
	if (txx(j1+k-1).gt.0.) then
	xxx(k)=txx(175+k)	! replace wrong TEC
	                          else
	xxx(k)=trem ! replace wrong TEC
	endif
	                                       endif
	txx(175+k)=xxx(k)
	trem=xxx(k)
	enddo
c-	if ((alat.le.glat1).and.(alat.gt.glat2)) then
c-	rat=(glat1-alat)/2.
c-      do k=0,179
c-	txx(3,k)=txx(1,k)+(txx(2,k)-txx(1,k))*rat
c-	txx(1,k)=txx(2,k)
c-	enddo
	glat1=glat2
C Interpolate in longi
	alon=-182.
c-      alon=-180.
c-	glon1=-182.
c-	jout=0
crem	DO jj=0,71 ! cycle on output longs
	DO jlon=0,179 ! cycle on intput longs
	alon=alon+2.
c-   27	glon2=glon1+2.
	yy(ii,jlon)=txx(jlon)
crem	jg1=jg1+1
c-	if ((alon.ge.glon1).and.(alon.lt.glon2)) then
c-	yy(ii,jout)=txx(3,jlon)+(txx(3,jlon+1)-txx(3,jlon))*(alon-glon1)/2.
c-	glon1=glon2
c-	alon=alon+5.
c-	jout=jout+1
c-	endif 
c-	 glon1=glon2
   	ENDDO
c-	yy(ii,72)=yy(ii,0)
c-	                        else
c-	glat1=glat2
c-	do k=0,179
c-	txx(1,k)=txx(2,k)
c-	enddo
c-	goto 10
c-	endif
   20	continue
	goto 22
C ============================================	
    9	write(*,*) ' end of file'
	pause ' '
	goto 22
    2	write(*,*) ' error in input file'
 	pause ' '
C
   22 continue
	return
	end
C
C ===============================================================
